using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Threading;
using System.Runtime.InteropServices;

using System.Net;
using System.Text;
using System.Text.RegularExpressions;
using System.IO;

namespace PhidgetServer
{
	/// <summary>
	/// Form1 ̊Tv̐łB
	/// </summary>
	public class PhidgetForm : System.Windows.Forms.Form
	{

		#region ϐ/萔
		PHIDGET.PhidgetAccelerometer phidgetAccel;
		PHIDGET.PhidgetRFID phidgetRFID;
		PHIDGET.PhidgetWeightSensor phidgetWeight;
		PHIDGET.PhidgetServo phidgetServo;
		PHIDGET.PhidgetManager phidgetManager;
		PHIDGET.PhidgetInterfaceKit phidgetInterface;

		const int TEXTBOX_CNT_MAX = 5000;

		const string PHIDGET_ACCEL_NAME = "PhidgetAccelerometer";
		const string PHIDGET_INTERFACE_NAME = "PhidgetInterfaceKit";
		const string PHIDGET_WEIGHT_NAME = "PhidgetWeightSensor";
		const string PHIDGET_RFID_NAME = "PhidgetRFID";
		const string PHIDGET_SERVO_NAME = "PhidgetServo";

		//ݒt@C
		const string SETTING_FILE = "setting.txt";
		const int SETTING_CNT = 8;

		//PhidgetServer̒`
		PhidgetServer server = null;
		
		//PhidgetRFIDĎXbh
		Thread rfidThread = null;
		bool rfidUpdated = false;
		
		//[JzXgIP
		const string LOCAL_IP = "127.0.0.1";
		
		//^OID
		string [] DISCARD_IDS = {"0c00000000", "0800000000"};
		
		#endregion
	
		#region Windows.Forms̐錾
		private System.ComponentModel.IContainer components;

		private CheckBox [] checkBoxInterfaces;
		private CheckBox [] checkBoxInputs;
		private CheckBox [] checkBoxOutputs;
		private NumericUpDown [] numericInterfaces;
		private NumericUpDown [] numericAccels;
		private NumericUpDown [] numericAccelTs;
		private NumericUpDown [] numericInterfaceTs;
		private System.Windows.Forms.GroupBox groupBoxRFID;
		private System.Windows.Forms.Label label6;
		private System.Windows.Forms.NumericUpDown numericUpDownRFID;
		private System.Windows.Forms.TextBox textBoxRFID;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.GroupBox groupBox1;
		private System.Windows.Forms.CheckBox checkBoxDebug;
		private System.Windows.Forms.TextBox textBoxMessage;
		private System.Windows.Forms.GroupBox groupBoxInterfacekit;
		private System.Windows.Forms.GroupBox groupBoxOutput;
		private System.Windows.Forms.CheckBox checkBoxOutput8;
		private System.Windows.Forms.CheckBox checkBoxOutput7;
		private System.Windows.Forms.CheckBox checkBoxOutput6;
		private System.Windows.Forms.CheckBox checkBoxOutput5;
		private System.Windows.Forms.CheckBox checkBoxOutput4;
		private System.Windows.Forms.CheckBox checkBoxOutput3;
		private System.Windows.Forms.CheckBox checkBoxOutput2;
		private System.Windows.Forms.CheckBox checkBoxOutput1;
		private System.Windows.Forms.GroupBox groupBoxInput;
		private System.Windows.Forms.CheckBox checkBoxInput8;
		private System.Windows.Forms.CheckBox checkBoxInput7;
		private System.Windows.Forms.CheckBox checkBoxInput6;
		private System.Windows.Forms.CheckBox checkBoxInput5;
		private System.Windows.Forms.CheckBox checkBoxInput4;
		private System.Windows.Forms.CheckBox checkBoxInput3;
		private System.Windows.Forms.CheckBox checkBoxInput2;
		private System.Windows.Forms.CheckBox checkBoxInput1;
		private System.Windows.Forms.GroupBox groupBoxSensor;
		private System.Windows.Forms.NumericUpDown numericUpDownInterfaceT8;
		private System.Windows.Forms.NumericUpDown numericUpDownInterfaceT7;
		private System.Windows.Forms.NumericUpDown numericUpDownInterfaceT1;
		private System.Windows.Forms.NumericUpDown numericUpDownInterfaceT6;
		private System.Windows.Forms.NumericUpDown numericUpDownInterfaceT5;
		private System.Windows.Forms.NumericUpDown numericUpDownInterfaceT4;
		private System.Windows.Forms.NumericUpDown numericUpDownInterfaceT3;
		private System.Windows.Forms.NumericUpDown numericUpDownInterfaceT2;
		private System.Windows.Forms.Label label15;
		private System.Windows.Forms.Label label14;
		private System.Windows.Forms.CheckBox checkBoxInterface8;
		private System.Windows.Forms.NumericUpDown numericUpDownInterface8;
		private System.Windows.Forms.CheckBox checkBoxInterface7;
		private System.Windows.Forms.NumericUpDown numericUpDownInterface7;
		private System.Windows.Forms.CheckBox checkBoxInterface6;
		private System.Windows.Forms.NumericUpDown numericUpDownInterface1;
		private System.Windows.Forms.NumericUpDown numericUpDownInterface6;
		private System.Windows.Forms.CheckBox checkBoxInterface5;
		private System.Windows.Forms.NumericUpDown numericUpDownInterface5;
		private System.Windows.Forms.CheckBox checkBoxInterface4;
		private System.Windows.Forms.NumericUpDown numericUpDownInterface4;
		private System.Windows.Forms.CheckBox checkBoxInterface3;
		private System.Windows.Forms.NumericUpDown numericUpDownInterface3;
		private System.Windows.Forms.CheckBox checkBoxInterface2;
		private System.Windows.Forms.NumericUpDown numericUpDownInterface2;
		private System.Windows.Forms.CheckBox checkBoxInterface1;
		private System.Windows.Forms.GroupBox groupBox2;
		private System.Windows.Forms.Label label12;
		private System.Windows.Forms.Label label11;
		private System.Windows.Forms.Label label10;
		private System.Windows.Forms.Label label9;
		private System.Windows.Forms.TrackBar trackBarServo4;
		private System.Windows.Forms.TrackBar trackBarServo3;
		private System.Windows.Forms.TrackBar trackBarServo2;
		private System.Windows.Forms.TrackBar trackBarServo1;
		private System.Windows.Forms.NumericUpDown numericUpDownServo4;
		private System.Windows.Forms.NumericUpDown numericUpDownServo3;
		private System.Windows.Forms.NumericUpDown numericUpDownServo2;
		private System.Windows.Forms.NumericUpDown numericUpDownServo1;
		private System.Windows.Forms.GroupBox groupBoxWeight;
		private System.Windows.Forms.Label label8;
		private System.Windows.Forms.NumericUpDown numericUpDownWeightThreshold;
		private System.Windows.Forms.Label label5;
		private System.Windows.Forms.NumericUpDown numericUpDownWeight;
		private System.Windows.Forms.GroupBox groupBoxAccel;
		private System.Windows.Forms.Label label7;
		private System.Windows.Forms.Label label4;
		private System.Windows.Forms.NumericUpDown numericUpDownAccelY;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.NumericUpDown numericUpDownAccelX;
		private System.Windows.Forms.Label label13;
		private System.Windows.Forms.GroupBox groupBoxServer;
		private System.Windows.Forms.Button buttonServerStop;
		private System.Windows.Forms.NumericUpDown numericUpDownServerPort;
		private System.Windows.Forms.Button buttonServerStart;
		private System.Windows.Forms.Label label16;
		private System.Windows.Forms.TextBox textBoxIP;
		private System.Windows.Forms.GroupBox groupBoxPhidget;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Label label17;
		private System.Windows.Forms.NumericUpDown numericUpDownAccelThresholdX;
		private System.Windows.Forms.Label label18;
		private System.Windows.Forms.NumericUpDown numericUpDownAccelThresholdY;
		private System.Windows.Forms.Label label19;
		private System.Windows.Forms.ComboBox comboBoxDelimiter;
		private System.Windows.Forms.CheckBox checkBoxLocalHost;
		private TrackBar [] trackBarServos;
		#endregion

		#region EI
		public PhidgetForm()
		{
			InitializeComponent();
			InitComponentArray();
			LoadSettings();
			StartManager();
		}

		//eUIR|[lgzɊi[
		void InitComponentArray()
		{
			numericInterfaces = new  System.Windows.Forms.NumericUpDown[8];
			numericInterfaces[0] = numericUpDownInterface1;
			numericInterfaces[1] = numericUpDownInterface2;
			numericInterfaces[2] = numericUpDownInterface3;
			numericInterfaces[3] = numericUpDownInterface4;
			numericInterfaces[4] = numericUpDownInterface5;
			numericInterfaces[5] = numericUpDownInterface6;
			numericInterfaces[6] = numericUpDownInterface7;
			numericInterfaces[7] = numericUpDownInterface8;

			numericInterfaceTs = new  System.Windows.Forms.NumericUpDown[8];
			numericInterfaceTs[0] = numericUpDownInterfaceT1;
			numericInterfaceTs[1] = numericUpDownInterfaceT2;
			numericInterfaceTs[2] = numericUpDownInterfaceT3;
			numericInterfaceTs[3] = numericUpDownInterfaceT4;
			numericInterfaceTs[4] = numericUpDownInterfaceT5;
			numericInterfaceTs[5] = numericUpDownInterfaceT6;
			numericInterfaceTs[6] = numericUpDownInterfaceT7;
			numericInterfaceTs[7] = numericUpDownInterfaceT8;

			checkBoxInterfaces = new  System.Windows.Forms.CheckBox[8];
			checkBoxInterfaces[0] = checkBoxInterface1;
			checkBoxInterfaces[1] = checkBoxInterface2;
			checkBoxInterfaces[2] = checkBoxInterface3;
			checkBoxInterfaces[3] = checkBoxInterface4;
			checkBoxInterfaces[4] = checkBoxInterface5;
			checkBoxInterfaces[5] = checkBoxInterface6;
			checkBoxInterfaces[6] = checkBoxInterface7;
			checkBoxInterfaces[7] = checkBoxInterface8;

			checkBoxInputs = new   System.Windows.Forms.CheckBox[8];
			checkBoxInputs[0] = checkBoxInput1;
			checkBoxInputs[1] = checkBoxInput2;
			checkBoxInputs[2] = checkBoxInput3;
			checkBoxInputs[3] = checkBoxInput4;
			checkBoxInputs[4] = checkBoxInput5;
			checkBoxInputs[5] = checkBoxInput6;
			checkBoxInputs[6] = checkBoxInput7;
			checkBoxInputs[7] = checkBoxInput8;

			checkBoxOutputs = new   System.Windows.Forms.CheckBox[8];
			checkBoxOutputs[0] = checkBoxOutput1;
			checkBoxOutputs[1] = checkBoxOutput2;
			checkBoxOutputs[2] = checkBoxOutput3;
			checkBoxOutputs[3] = checkBoxOutput4;
			checkBoxOutputs[4] = checkBoxOutput5;
			checkBoxOutputs[5] = checkBoxOutput6;
			checkBoxOutputs[6] = checkBoxOutput7;
			checkBoxOutputs[7] = checkBoxOutput8;

			numericAccels = new System.Windows.Forms.NumericUpDown[2];
			numericAccels[0] = numericUpDownAccelX;
			numericAccels[1] = numericUpDownAccelY;

			numericAccelTs = new System.Windows.Forms.NumericUpDown[2];
			numericAccelTs[0] = numericUpDownAccelThresholdX;
			numericAccelTs[1] = numericUpDownAccelThresholdY;

			trackBarServos = new System.Windows.Forms.TrackBar[4];
			trackBarServos[0] = trackBarServo1;
			trackBarServos[1] = trackBarServo2;
			trackBarServos[2] = trackBarServo3;
			trackBarServos[3] = trackBarServo4;


			return;
		}

		/// <summary>
		/// gpĂ郊\[XɌ㏈s܂B
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			SaveSettings();

			if(rfidThread != null)
			{
				rfidThread.Abort();
				rfidThread = null;
			}

			phidgetManager = null;

			if(server != null)
				server.Stop();

			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#endregion

		#region Windows tH[ fUCiŐꂽR[h 
		/// <summary>
		/// fUCi T|[gɕKvȃ\bhłB̃\bh̓e
		/// R[h GfB^ŕύXȂłB
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(PhidgetForm));
			this.groupBoxRFID = new System.Windows.Forms.GroupBox();
			this.label6 = new System.Windows.Forms.Label();
			this.numericUpDownRFID = new System.Windows.Forms.NumericUpDown();
			this.textBoxRFID = new System.Windows.Forms.TextBox();
			this.label2 = new System.Windows.Forms.Label();
			this.groupBox1 = new System.Windows.Forms.GroupBox();
			this.checkBoxDebug = new System.Windows.Forms.CheckBox();
			this.textBoxMessage = new System.Windows.Forms.TextBox();
			this.groupBoxInterfacekit = new System.Windows.Forms.GroupBox();
			this.groupBoxOutput = new System.Windows.Forms.GroupBox();
			this.checkBoxOutput8 = new System.Windows.Forms.CheckBox();
			this.checkBoxOutput7 = new System.Windows.Forms.CheckBox();
			this.checkBoxOutput6 = new System.Windows.Forms.CheckBox();
			this.checkBoxOutput5 = new System.Windows.Forms.CheckBox();
			this.checkBoxOutput4 = new System.Windows.Forms.CheckBox();
			this.checkBoxOutput3 = new System.Windows.Forms.CheckBox();
			this.checkBoxOutput2 = new System.Windows.Forms.CheckBox();
			this.checkBoxOutput1 = new System.Windows.Forms.CheckBox();
			this.groupBoxInput = new System.Windows.Forms.GroupBox();
			this.checkBoxInput8 = new System.Windows.Forms.CheckBox();
			this.checkBoxInput7 = new System.Windows.Forms.CheckBox();
			this.checkBoxInput6 = new System.Windows.Forms.CheckBox();
			this.checkBoxInput5 = new System.Windows.Forms.CheckBox();
			this.checkBoxInput4 = new System.Windows.Forms.CheckBox();
			this.checkBoxInput3 = new System.Windows.Forms.CheckBox();
			this.checkBoxInput2 = new System.Windows.Forms.CheckBox();
			this.checkBoxInput1 = new System.Windows.Forms.CheckBox();
			this.groupBoxSensor = new System.Windows.Forms.GroupBox();
			this.numericUpDownInterfaceT8 = new System.Windows.Forms.NumericUpDown();
			this.numericUpDownInterfaceT7 = new System.Windows.Forms.NumericUpDown();
			this.numericUpDownInterfaceT1 = new System.Windows.Forms.NumericUpDown();
			this.numericUpDownInterfaceT6 = new System.Windows.Forms.NumericUpDown();
			this.numericUpDownInterfaceT5 = new System.Windows.Forms.NumericUpDown();
			this.numericUpDownInterfaceT4 = new System.Windows.Forms.NumericUpDown();
			this.numericUpDownInterfaceT3 = new System.Windows.Forms.NumericUpDown();
			this.numericUpDownInterfaceT2 = new System.Windows.Forms.NumericUpDown();
			this.label15 = new System.Windows.Forms.Label();
			this.label14 = new System.Windows.Forms.Label();
			this.checkBoxInterface8 = new System.Windows.Forms.CheckBox();
			this.numericUpDownInterface8 = new System.Windows.Forms.NumericUpDown();
			this.checkBoxInterface7 = new System.Windows.Forms.CheckBox();
			this.numericUpDownInterface7 = new System.Windows.Forms.NumericUpDown();
			this.checkBoxInterface6 = new System.Windows.Forms.CheckBox();
			this.numericUpDownInterface1 = new System.Windows.Forms.NumericUpDown();
			this.numericUpDownInterface6 = new System.Windows.Forms.NumericUpDown();
			this.checkBoxInterface5 = new System.Windows.Forms.CheckBox();
			this.numericUpDownInterface5 = new System.Windows.Forms.NumericUpDown();
			this.checkBoxInterface4 = new System.Windows.Forms.CheckBox();
			this.numericUpDownInterface4 = new System.Windows.Forms.NumericUpDown();
			this.checkBoxInterface3 = new System.Windows.Forms.CheckBox();
			this.numericUpDownInterface3 = new System.Windows.Forms.NumericUpDown();
			this.checkBoxInterface2 = new System.Windows.Forms.CheckBox();
			this.numericUpDownInterface2 = new System.Windows.Forms.NumericUpDown();
			this.checkBoxInterface1 = new System.Windows.Forms.CheckBox();
			this.groupBox2 = new System.Windows.Forms.GroupBox();
			this.label12 = new System.Windows.Forms.Label();
			this.label11 = new System.Windows.Forms.Label();
			this.label10 = new System.Windows.Forms.Label();
			this.label9 = new System.Windows.Forms.Label();
			this.trackBarServo4 = new System.Windows.Forms.TrackBar();
			this.trackBarServo3 = new System.Windows.Forms.TrackBar();
			this.trackBarServo2 = new System.Windows.Forms.TrackBar();
			this.trackBarServo1 = new System.Windows.Forms.TrackBar();
			this.numericUpDownServo4 = new System.Windows.Forms.NumericUpDown();
			this.numericUpDownServo3 = new System.Windows.Forms.NumericUpDown();
			this.numericUpDownServo2 = new System.Windows.Forms.NumericUpDown();
			this.numericUpDownServo1 = new System.Windows.Forms.NumericUpDown();
			this.groupBoxWeight = new System.Windows.Forms.GroupBox();
			this.label1 = new System.Windows.Forms.Label();
			this.label8 = new System.Windows.Forms.Label();
			this.numericUpDownWeightThreshold = new System.Windows.Forms.NumericUpDown();
			this.label5 = new System.Windows.Forms.Label();
			this.numericUpDownWeight = new System.Windows.Forms.NumericUpDown();
			this.label17 = new System.Windows.Forms.Label();
			this.groupBoxAccel = new System.Windows.Forms.GroupBox();
			this.label18 = new System.Windows.Forms.Label();
			this.numericUpDownAccelThresholdY = new System.Windows.Forms.NumericUpDown();
			this.label7 = new System.Windows.Forms.Label();
			this.numericUpDownAccelThresholdX = new System.Windows.Forms.NumericUpDown();
			this.label4 = new System.Windows.Forms.Label();
			this.numericUpDownAccelY = new System.Windows.Forms.NumericUpDown();
			this.label3 = new System.Windows.Forms.Label();
			this.numericUpDownAccelX = new System.Windows.Forms.NumericUpDown();
			this.label13 = new System.Windows.Forms.Label();
			this.groupBoxServer = new System.Windows.Forms.GroupBox();
			this.checkBoxLocalHost = new System.Windows.Forms.CheckBox();
			this.comboBoxDelimiter = new System.Windows.Forms.ComboBox();
			this.label19 = new System.Windows.Forms.Label();
			this.textBoxIP = new System.Windows.Forms.TextBox();
			this.label16 = new System.Windows.Forms.Label();
			this.buttonServerStop = new System.Windows.Forms.Button();
			this.numericUpDownServerPort = new System.Windows.Forms.NumericUpDown();
			this.buttonServerStart = new System.Windows.Forms.Button();
			this.groupBoxPhidget = new System.Windows.Forms.GroupBox();
			this.groupBoxRFID.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownRFID)).BeginInit();
			this.groupBox1.SuspendLayout();
			this.groupBoxInterfacekit.SuspendLayout();
			this.groupBoxOutput.SuspendLayout();
			this.groupBoxInput.SuspendLayout();
			this.groupBoxSensor.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownInterfaceT8)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownInterfaceT7)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownInterfaceT1)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownInterfaceT6)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownInterfaceT5)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownInterfaceT4)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownInterfaceT3)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownInterfaceT2)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownInterface8)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownInterface7)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownInterface1)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownInterface6)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownInterface5)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownInterface4)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownInterface3)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownInterface2)).BeginInit();
			this.groupBox2.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.trackBarServo4)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.trackBarServo3)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.trackBarServo2)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.trackBarServo1)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownServo4)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownServo3)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownServo2)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownServo1)).BeginInit();
			this.groupBoxWeight.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownWeightThreshold)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownWeight)).BeginInit();
			this.groupBoxAccel.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownAccelThresholdY)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownAccelThresholdX)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownAccelY)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownAccelX)).BeginInit();
			this.groupBoxServer.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownServerPort)).BeginInit();
			this.groupBoxPhidget.SuspendLayout();
			this.SuspendLayout();
			// 
			// groupBoxRFID
			// 
			this.groupBoxRFID.Controls.Add(this.label6);
			this.groupBoxRFID.Controls.Add(this.numericUpDownRFID);
			this.groupBoxRFID.Controls.Add(this.textBoxRFID);
			this.groupBoxRFID.Controls.Add(this.label2);
			this.groupBoxRFID.Location = new System.Drawing.Point(8, 176);
			this.groupBoxRFID.Name = "groupBoxRFID";
			this.groupBoxRFID.Size = new System.Drawing.Size(152, 64);
			this.groupBoxRFID.TabIndex = 2;
			this.groupBoxRFID.TabStop = false;
			this.groupBoxRFID.Text = "RFID";
			// 
			// label6
			// 
			this.label6.Location = new System.Drawing.Point(16, 40);
			this.label6.Name = "label6";
			this.label6.Size = new System.Drawing.Size(56, 16);
			this.label6.TabIndex = 25;
			this.label6.Text = "臒l(b):";
			// 
			// numericUpDownRFID
			// 
			this.numericUpDownRFID.DecimalPlaces = 1;
			this.numericUpDownRFID.Location = new System.Drawing.Point(96, 40);
			this.numericUpDownRFID.Minimum = new System.Decimal(new int[] {
																			  1,
																			  0,
																			  0,
																			  0});
			this.numericUpDownRFID.Name = "numericUpDownRFID";
			this.numericUpDownRFID.Size = new System.Drawing.Size(48, 19);
			this.numericUpDownRFID.TabIndex = 2;
			this.numericUpDownRFID.Value = new System.Decimal(new int[] {
																			1,
																			0,
																			0,
																			0});
			this.numericUpDownRFID.ValueChanged += new System.EventHandler(this.numericUpDownRFID_ValueChanged);
			// 
			// textBoxRFID
			// 
			this.textBoxRFID.Location = new System.Drawing.Point(48, 16);
			this.textBoxRFID.Name = "textBoxRFID";
			this.textBoxRFID.ReadOnly = true;
			this.textBoxRFID.Size = new System.Drawing.Size(96, 19);
			this.textBoxRFID.TabIndex = 1;
			this.textBoxRFID.Text = "";
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(16, 16);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(32, 16);
			this.label2.TabIndex = 22;
			this.label2.Text = "ID:";
			// 
			// groupBox1
			// 
			this.groupBox1.Controls.Add(this.checkBoxDebug);
			this.groupBox1.Controls.Add(this.textBoxMessage);
			this.groupBox1.Location = new System.Drawing.Point(280, 0);
			this.groupBox1.Name = "groupBox1";
			this.groupBox1.Size = new System.Drawing.Size(304, 96);
			this.groupBox1.TabIndex = 2;
			this.groupBox1.TabStop = false;
			this.groupBox1.Text = "bZ[W";
			// 
			// checkBoxDebug
			// 
			this.checkBoxDebug.Location = new System.Drawing.Point(16, 75);
			this.checkBoxDebug.Name = "checkBoxDebug";
			this.checkBoxDebug.Size = new System.Drawing.Size(168, 16);
			this.checkBoxDebug.TabIndex = 1;
			this.checkBoxDebug.Text = "fobObZ[W\";
			// 
			// textBoxMessage
			// 
			this.textBoxMessage.Location = new System.Drawing.Point(8, 16);
			this.textBoxMessage.Multiline = true;
			this.textBoxMessage.Name = "textBoxMessage";
			this.textBoxMessage.ReadOnly = true;
			this.textBoxMessage.ScrollBars = System.Windows.Forms.ScrollBars.Both;
			this.textBoxMessage.Size = new System.Drawing.Size(288, 56);
			this.textBoxMessage.TabIndex = 16;
			this.textBoxMessage.TabStop = false;
			this.textBoxMessage.Text = "";
			// 
			// groupBoxInterfacekit
			// 
			this.groupBoxInterfacekit.Controls.Add(this.groupBoxOutput);
			this.groupBoxInterfacekit.Controls.Add(this.groupBoxInput);
			this.groupBoxInterfacekit.Controls.Add(this.groupBoxSensor);
			this.groupBoxInterfacekit.Location = new System.Drawing.Point(8, 16);
			this.groupBoxInterfacekit.Name = "groupBoxInterfacekit";
			this.groupBoxInterfacekit.Size = new System.Drawing.Size(560, 152);
			this.groupBoxInterfacekit.TabIndex = 1;
			this.groupBoxInterfacekit.TabStop = false;
			this.groupBoxInterfacekit.Text = "C^tF[XLbg";
			// 
			// groupBoxOutput
			// 
			this.groupBoxOutput.Controls.Add(this.checkBoxOutput8);
			this.groupBoxOutput.Controls.Add(this.checkBoxOutput7);
			this.groupBoxOutput.Controls.Add(this.checkBoxOutput6);
			this.groupBoxOutput.Controls.Add(this.checkBoxOutput5);
			this.groupBoxOutput.Controls.Add(this.checkBoxOutput4);
			this.groupBoxOutput.Controls.Add(this.checkBoxOutput3);
			this.groupBoxOutput.Controls.Add(this.checkBoxOutput2);
			this.groupBoxOutput.Controls.Add(this.checkBoxOutput1);
			this.groupBoxOutput.Location = new System.Drawing.Point(280, 104);
			this.groupBoxOutput.Name = "groupBoxOutput";
			this.groupBoxOutput.Size = new System.Drawing.Size(272, 40);
			this.groupBoxOutput.TabIndex = 3;
			this.groupBoxOutput.TabStop = false;
			this.groupBoxOutput.Text = "fW^o";
			// 
			// checkBoxOutput8
			// 
			this.checkBoxOutput8.Location = new System.Drawing.Point(240, 16);
			this.checkBoxOutput8.Name = "checkBoxOutput8";
			this.checkBoxOutput8.Size = new System.Drawing.Size(28, 16);
			this.checkBoxOutput8.TabIndex = 8;
			this.checkBoxOutput8.Text = "7";
			this.checkBoxOutput8.CheckedChanged += new System.EventHandler(this.checkBoxOutput8_CheckedChanged);
			// 
			// checkBoxOutput7
			// 
			this.checkBoxOutput7.Location = new System.Drawing.Point(208, 16);
			this.checkBoxOutput7.Name = "checkBoxOutput7";
			this.checkBoxOutput7.Size = new System.Drawing.Size(28, 16);
			this.checkBoxOutput7.TabIndex = 7;
			this.checkBoxOutput7.Text = "6";
			this.checkBoxOutput7.CheckedChanged += new System.EventHandler(this.checkBoxOutput7_CheckedChanged);
			// 
			// checkBoxOutput6
			// 
			this.checkBoxOutput6.Location = new System.Drawing.Point(176, 16);
			this.checkBoxOutput6.Name = "checkBoxOutput6";
			this.checkBoxOutput6.Size = new System.Drawing.Size(28, 16);
			this.checkBoxOutput6.TabIndex = 6;
			this.checkBoxOutput6.Text = "5";
			this.checkBoxOutput6.CheckedChanged += new System.EventHandler(this.checkBoxOutput6_CheckedChanged);
			// 
			// checkBoxOutput5
			// 
			this.checkBoxOutput5.Location = new System.Drawing.Point(144, 16);
			this.checkBoxOutput5.Name = "checkBoxOutput5";
			this.checkBoxOutput5.Size = new System.Drawing.Size(28, 16);
			this.checkBoxOutput5.TabIndex = 5;
			this.checkBoxOutput5.Text = "4";
			this.checkBoxOutput5.CheckedChanged += new System.EventHandler(this.checkBoxOutput5_CheckedChanged);
			// 
			// checkBoxOutput4
			// 
			this.checkBoxOutput4.Location = new System.Drawing.Point(112, 16);
			this.checkBoxOutput4.Name = "checkBoxOutput4";
			this.checkBoxOutput4.Size = new System.Drawing.Size(28, 16);
			this.checkBoxOutput4.TabIndex = 4;
			this.checkBoxOutput4.Text = "3";
			this.checkBoxOutput4.CheckedChanged += new System.EventHandler(this.checkBoxOutput4_CheckedChanged);
			// 
			// checkBoxOutput3
			// 
			this.checkBoxOutput3.Location = new System.Drawing.Point(80, 16);
			this.checkBoxOutput3.Name = "checkBoxOutput3";
			this.checkBoxOutput3.Size = new System.Drawing.Size(28, 16);
			this.checkBoxOutput3.TabIndex = 3;
			this.checkBoxOutput3.Text = "2";
			this.checkBoxOutput3.CheckedChanged += new System.EventHandler(this.checkBoxOutput3_CheckedChanged);
			// 
			// checkBoxOutput2
			// 
			this.checkBoxOutput2.Location = new System.Drawing.Point(48, 16);
			this.checkBoxOutput2.Name = "checkBoxOutput2";
			this.checkBoxOutput2.Size = new System.Drawing.Size(28, 16);
			this.checkBoxOutput2.TabIndex = 2;
			this.checkBoxOutput2.Text = "1";
			this.checkBoxOutput2.CheckedChanged += new System.EventHandler(this.checkBoxOutput2_CheckedChanged);
			// 
			// checkBoxOutput1
			// 
			this.checkBoxOutput1.Location = new System.Drawing.Point(8, 16);
			this.checkBoxOutput1.Name = "checkBoxOutput1";
			this.checkBoxOutput1.Size = new System.Drawing.Size(36, 16);
			this.checkBoxOutput1.TabIndex = 1;
			this.checkBoxOutput1.Text = "0";
			this.checkBoxOutput1.CheckedChanged += new System.EventHandler(this.checkBoxOutput1_CheckedChanged);
			// 
			// groupBoxInput
			// 
			this.groupBoxInput.Controls.Add(this.checkBoxInput8);
			this.groupBoxInput.Controls.Add(this.checkBoxInput7);
			this.groupBoxInput.Controls.Add(this.checkBoxInput6);
			this.groupBoxInput.Controls.Add(this.checkBoxInput5);
			this.groupBoxInput.Controls.Add(this.checkBoxInput4);
			this.groupBoxInput.Controls.Add(this.checkBoxInput3);
			this.groupBoxInput.Controls.Add(this.checkBoxInput2);
			this.groupBoxInput.Controls.Add(this.checkBoxInput1);
			this.groupBoxInput.Location = new System.Drawing.Point(8, 104);
			this.groupBoxInput.Name = "groupBoxInput";
			this.groupBoxInput.Size = new System.Drawing.Size(272, 40);
			this.groupBoxInput.TabIndex = 2;
			this.groupBoxInput.TabStop = false;
			this.groupBoxInput.Text = "fW^";
			// 
			// checkBoxInput8
			// 
			this.checkBoxInput8.Enabled = false;
			this.checkBoxInput8.Location = new System.Drawing.Point(240, 16);
			this.checkBoxInput8.Name = "checkBoxInput8";
			this.checkBoxInput8.Size = new System.Drawing.Size(28, 16);
			this.checkBoxInput8.TabIndex = 44;
			this.checkBoxInput8.TabStop = false;
			this.checkBoxInput8.Text = "7";
			// 
			// checkBoxInput7
			// 
			this.checkBoxInput7.Enabled = false;
			this.checkBoxInput7.Location = new System.Drawing.Point(208, 16);
			this.checkBoxInput7.Name = "checkBoxInput7";
			this.checkBoxInput7.Size = new System.Drawing.Size(28, 16);
			this.checkBoxInput7.TabIndex = 43;
			this.checkBoxInput7.TabStop = false;
			this.checkBoxInput7.Text = "6";
			// 
			// checkBoxInput6
			// 
			this.checkBoxInput6.Enabled = false;
			this.checkBoxInput6.Location = new System.Drawing.Point(176, 16);
			this.checkBoxInput6.Name = "checkBoxInput6";
			this.checkBoxInput6.Size = new System.Drawing.Size(28, 16);
			this.checkBoxInput6.TabIndex = 42;
			this.checkBoxInput6.TabStop = false;
			this.checkBoxInput6.Text = "5";
			// 
			// checkBoxInput5
			// 
			this.checkBoxInput5.Enabled = false;
			this.checkBoxInput5.Location = new System.Drawing.Point(144, 16);
			this.checkBoxInput5.Name = "checkBoxInput5";
			this.checkBoxInput5.Size = new System.Drawing.Size(28, 16);
			this.checkBoxInput5.TabIndex = 41;
			this.checkBoxInput5.TabStop = false;
			this.checkBoxInput5.Text = "4";
			// 
			// checkBoxInput4
			// 
			this.checkBoxInput4.Enabled = false;
			this.checkBoxInput4.Location = new System.Drawing.Point(112, 16);
			this.checkBoxInput4.Name = "checkBoxInput4";
			this.checkBoxInput4.Size = new System.Drawing.Size(28, 16);
			this.checkBoxInput4.TabIndex = 40;
			this.checkBoxInput4.TabStop = false;
			this.checkBoxInput4.Text = "3";
			// 
			// checkBoxInput3
			// 
			this.checkBoxInput3.Enabled = false;
			this.checkBoxInput3.Location = new System.Drawing.Point(80, 16);
			this.checkBoxInput3.Name = "checkBoxInput3";
			this.checkBoxInput3.Size = new System.Drawing.Size(28, 16);
			this.checkBoxInput3.TabIndex = 39;
			this.checkBoxInput3.TabStop = false;
			this.checkBoxInput3.Text = "2";
			// 
			// checkBoxInput2
			// 
			this.checkBoxInput2.Enabled = false;
			this.checkBoxInput2.Location = new System.Drawing.Point(48, 16);
			this.checkBoxInput2.Name = "checkBoxInput2";
			this.checkBoxInput2.Size = new System.Drawing.Size(28, 16);
			this.checkBoxInput2.TabIndex = 2;
			this.checkBoxInput2.TabStop = false;
			this.checkBoxInput2.Text = "1";
			// 
			// checkBoxInput1
			// 
			this.checkBoxInput1.Enabled = false;
			this.checkBoxInput1.Location = new System.Drawing.Point(8, 16);
			this.checkBoxInput1.Name = "checkBoxInput1";
			this.checkBoxInput1.Size = new System.Drawing.Size(36, 16);
			this.checkBoxInput1.TabIndex = 1;
			this.checkBoxInput1.TabStop = false;
			this.checkBoxInput1.Text = "0";
			// 
			// groupBoxSensor
			// 
			this.groupBoxSensor.Controls.Add(this.numericUpDownInterfaceT8);
			this.groupBoxSensor.Controls.Add(this.numericUpDownInterfaceT7);
			this.groupBoxSensor.Controls.Add(this.numericUpDownInterfaceT1);
			this.groupBoxSensor.Controls.Add(this.numericUpDownInterfaceT6);
			this.groupBoxSensor.Controls.Add(this.numericUpDownInterfaceT5);
			this.groupBoxSensor.Controls.Add(this.numericUpDownInterfaceT4);
			this.groupBoxSensor.Controls.Add(this.numericUpDownInterfaceT3);
			this.groupBoxSensor.Controls.Add(this.numericUpDownInterfaceT2);
			this.groupBoxSensor.Controls.Add(this.label15);
			this.groupBoxSensor.Controls.Add(this.label14);
			this.groupBoxSensor.Controls.Add(this.checkBoxInterface8);
			this.groupBoxSensor.Controls.Add(this.numericUpDownInterface8);
			this.groupBoxSensor.Controls.Add(this.checkBoxInterface7);
			this.groupBoxSensor.Controls.Add(this.numericUpDownInterface7);
			this.groupBoxSensor.Controls.Add(this.checkBoxInterface6);
			this.groupBoxSensor.Controls.Add(this.numericUpDownInterface1);
			this.groupBoxSensor.Controls.Add(this.numericUpDownInterface6);
			this.groupBoxSensor.Controls.Add(this.checkBoxInterface5);
			this.groupBoxSensor.Controls.Add(this.numericUpDownInterface5);
			this.groupBoxSensor.Controls.Add(this.checkBoxInterface4);
			this.groupBoxSensor.Controls.Add(this.numericUpDownInterface4);
			this.groupBoxSensor.Controls.Add(this.checkBoxInterface3);
			this.groupBoxSensor.Controls.Add(this.numericUpDownInterface3);
			this.groupBoxSensor.Controls.Add(this.checkBoxInterface2);
			this.groupBoxSensor.Controls.Add(this.numericUpDownInterface2);
			this.groupBoxSensor.Controls.Add(this.checkBoxInterface1);
			this.groupBoxSensor.Location = new System.Drawing.Point(8, 16);
			this.groupBoxSensor.Name = "groupBoxSensor";
			this.groupBoxSensor.Size = new System.Drawing.Size(448, 88);
			this.groupBoxSensor.TabIndex = 1;
			this.groupBoxSensor.TabStop = false;
			this.groupBoxSensor.Text = "ZT";
			// 
			// numericUpDownInterfaceT8
			// 
			this.numericUpDownInterfaceT8.Location = new System.Drawing.Point(392, 56);
			this.numericUpDownInterfaceT8.Maximum = new System.Decimal(new int[] {
																					 1024,
																					 0,
																					 0,
																					 0});
			this.numericUpDownInterfaceT8.Name = "numericUpDownInterfaceT8";
			this.numericUpDownInterfaceT8.Size = new System.Drawing.Size(40, 19);
			this.numericUpDownInterfaceT8.TabIndex = 16;
			this.numericUpDownInterfaceT8.Value = new System.Decimal(new int[] {
																				   50,
																				   0,
																				   0,
																				   0});
			this.numericUpDownInterfaceT8.ValueChanged += new System.EventHandler(this.numericUpDownInterfaceT8_ValueChanged);
			// 
			// numericUpDownInterfaceT7
			// 
			this.numericUpDownInterfaceT7.Location = new System.Drawing.Point(344, 56);
			this.numericUpDownInterfaceT7.Maximum = new System.Decimal(new int[] {
																					 1024,
																					 0,
																					 0,
																					 0});
			this.numericUpDownInterfaceT7.Name = "numericUpDownInterfaceT7";
			this.numericUpDownInterfaceT7.Size = new System.Drawing.Size(40, 19);
			this.numericUpDownInterfaceT7.TabIndex = 15;
			this.numericUpDownInterfaceT7.Value = new System.Decimal(new int[] {
																				   50,
																				   0,
																				   0,
																				   0});
			this.numericUpDownInterfaceT7.ValueChanged += new System.EventHandler(this.numericUpDownInterfaceT7_ValueChanged);
			// 
			// numericUpDownInterfaceT1
			// 
			this.numericUpDownInterfaceT1.Location = new System.Drawing.Point(56, 56);
			this.numericUpDownInterfaceT1.Maximum = new System.Decimal(new int[] {
																					 1024,
																					 0,
																					 0,
																					 0});
			this.numericUpDownInterfaceT1.Name = "numericUpDownInterfaceT1";
			this.numericUpDownInterfaceT1.Size = new System.Drawing.Size(40, 19);
			this.numericUpDownInterfaceT1.TabIndex = 9;
			this.numericUpDownInterfaceT1.Value = new System.Decimal(new int[] {
																				   50,
																				   0,
																				   0,
																				   0});
			this.numericUpDownInterfaceT1.ValueChanged += new System.EventHandler(this.numericUpDownInterfaceT1_ValueChanged);
			// 
			// numericUpDownInterfaceT6
			// 
			this.numericUpDownInterfaceT6.Location = new System.Drawing.Point(296, 56);
			this.numericUpDownInterfaceT6.Maximum = new System.Decimal(new int[] {
																					 1024,
																					 0,
																					 0,
																					 0});
			this.numericUpDownInterfaceT6.Name = "numericUpDownInterfaceT6";
			this.numericUpDownInterfaceT6.Size = new System.Drawing.Size(40, 19);
			this.numericUpDownInterfaceT6.TabIndex = 14;
			this.numericUpDownInterfaceT6.Value = new System.Decimal(new int[] {
																				   50,
																				   0,
																				   0,
																				   0});
			this.numericUpDownInterfaceT6.ValueChanged += new System.EventHandler(this.numericUpDownInterfaceT6_ValueChanged);
			// 
			// numericUpDownInterfaceT5
			// 
			this.numericUpDownInterfaceT5.Location = new System.Drawing.Point(248, 56);
			this.numericUpDownInterfaceT5.Maximum = new System.Decimal(new int[] {
																					 1024,
																					 0,
																					 0,
																					 0});
			this.numericUpDownInterfaceT5.Name = "numericUpDownInterfaceT5";
			this.numericUpDownInterfaceT5.Size = new System.Drawing.Size(40, 19);
			this.numericUpDownInterfaceT5.TabIndex = 13;
			this.numericUpDownInterfaceT5.Value = new System.Decimal(new int[] {
																				   50,
																				   0,
																				   0,
																				   0});
			this.numericUpDownInterfaceT5.ValueChanged += new System.EventHandler(this.numericUpDownInterfaceT5_ValueChanged);
			// 
			// numericUpDownInterfaceT4
			// 
			this.numericUpDownInterfaceT4.Location = new System.Drawing.Point(200, 56);
			this.numericUpDownInterfaceT4.Maximum = new System.Decimal(new int[] {
																					 1024,
																					 0,
																					 0,
																					 0});
			this.numericUpDownInterfaceT4.Name = "numericUpDownInterfaceT4";
			this.numericUpDownInterfaceT4.Size = new System.Drawing.Size(40, 19);
			this.numericUpDownInterfaceT4.TabIndex = 12;
			this.numericUpDownInterfaceT4.Value = new System.Decimal(new int[] {
																				   50,
																				   0,
																				   0,
																				   0});
			this.numericUpDownInterfaceT4.ValueChanged += new System.EventHandler(this.numericUpDownInterfaceT4_ValueChanged);
			// 
			// numericUpDownInterfaceT3
			// 
			this.numericUpDownInterfaceT3.Location = new System.Drawing.Point(152, 56);
			this.numericUpDownInterfaceT3.Maximum = new System.Decimal(new int[] {
																					 1024,
																					 0,
																					 0,
																					 0});
			this.numericUpDownInterfaceT3.Name = "numericUpDownInterfaceT3";
			this.numericUpDownInterfaceT3.Size = new System.Drawing.Size(40, 19);
			this.numericUpDownInterfaceT3.TabIndex = 11;
			this.numericUpDownInterfaceT3.Value = new System.Decimal(new int[] {
																				   50,
																				   0,
																				   0,
																				   0});
			this.numericUpDownInterfaceT3.ValueChanged += new System.EventHandler(this.numericUpDownInterfaceT3_ValueChanged);
			// 
			// numericUpDownInterfaceT2
			// 
			this.numericUpDownInterfaceT2.Location = new System.Drawing.Point(104, 56);
			this.numericUpDownInterfaceT2.Maximum = new System.Decimal(new int[] {
																					 1024,
																					 0,
																					 0,
																					 0});
			this.numericUpDownInterfaceT2.Name = "numericUpDownInterfaceT2";
			this.numericUpDownInterfaceT2.Size = new System.Drawing.Size(40, 19);
			this.numericUpDownInterfaceT2.TabIndex = 10;
			this.numericUpDownInterfaceT2.Value = new System.Decimal(new int[] {
																				   50,
																				   0,
																				   0,
																				   0});
			this.numericUpDownInterfaceT2.ValueChanged += new System.EventHandler(this.numericUpDownInterfaceT2_ValueChanged);
			// 
			// label15
			// 
			this.label15.Location = new System.Drawing.Point(8, 32);
			this.label15.Name = "label15";
			this.label15.Size = new System.Drawing.Size(40, 16);
			this.label15.TabIndex = 38;
			this.label15.Text = "l:";
			// 
			// label14
			// 
			this.label14.Location = new System.Drawing.Point(8, 56);
			this.label14.Name = "label14";
			this.label14.Size = new System.Drawing.Size(32, 16);
			this.label14.TabIndex = 37;
			this.label14.Text = "臒l:";
			// 
			// checkBoxInterface8
			// 
			this.checkBoxInterface8.Enabled = false;
			this.checkBoxInterface8.Location = new System.Drawing.Point(384, 16);
			this.checkBoxInterface8.Name = "checkBoxInterface8";
			this.checkBoxInterface8.Size = new System.Drawing.Size(48, 16);
			this.checkBoxInterface8.TabIndex = 36;
			this.checkBoxInterface8.TabStop = false;
			this.checkBoxInterface8.Text = "ch7";
			// 
			// numericUpDownInterface8
			// 
			this.numericUpDownInterface8.Location = new System.Drawing.Point(384, 32);
			this.numericUpDownInterface8.Maximum = new System.Decimal(new int[] {
																					1024,
																					0,
																					0,
																					0});
			this.numericUpDownInterface8.Name = "numericUpDownInterface8";
			this.numericUpDownInterface8.ReadOnly = true;
			this.numericUpDownInterface8.Size = new System.Drawing.Size(48, 19);
			this.numericUpDownInterface8.TabIndex = 8;
			// 
			// checkBoxInterface7
			// 
			this.checkBoxInterface7.Enabled = false;
			this.checkBoxInterface7.Location = new System.Drawing.Point(336, 16);
			this.checkBoxInterface7.Name = "checkBoxInterface7";
			this.checkBoxInterface7.Size = new System.Drawing.Size(48, 16);
			this.checkBoxInterface7.TabIndex = 34;
			this.checkBoxInterface7.TabStop = false;
			this.checkBoxInterface7.Text = "ch6";
			// 
			// numericUpDownInterface7
			// 
			this.numericUpDownInterface7.Location = new System.Drawing.Point(336, 32);
			this.numericUpDownInterface7.Maximum = new System.Decimal(new int[] {
																					1024,
																					0,
																					0,
																					0});
			this.numericUpDownInterface7.Name = "numericUpDownInterface7";
			this.numericUpDownInterface7.ReadOnly = true;
			this.numericUpDownInterface7.Size = new System.Drawing.Size(48, 19);
			this.numericUpDownInterface7.TabIndex = 7;
			// 
			// checkBoxInterface6
			// 
			this.checkBoxInterface6.Enabled = false;
			this.checkBoxInterface6.Location = new System.Drawing.Point(288, 16);
			this.checkBoxInterface6.Name = "checkBoxInterface6";
			this.checkBoxInterface6.Size = new System.Drawing.Size(48, 16);
			this.checkBoxInterface6.TabIndex = 32;
			this.checkBoxInterface6.TabStop = false;
			this.checkBoxInterface6.Text = "ch5";
			// 
			// numericUpDownInterface1
			// 
			this.numericUpDownInterface1.Location = new System.Drawing.Point(48, 32);
			this.numericUpDownInterface1.Maximum = new System.Decimal(new int[] {
																					1024,
																					0,
																					0,
																					0});
			this.numericUpDownInterface1.Name = "numericUpDownInterface1";
			this.numericUpDownInterface1.ReadOnly = true;
			this.numericUpDownInterface1.Size = new System.Drawing.Size(48, 19);
			this.numericUpDownInterface1.TabIndex = 1;
			// 
			// numericUpDownInterface6
			// 
			this.numericUpDownInterface6.Location = new System.Drawing.Point(288, 32);
			this.numericUpDownInterface6.Maximum = new System.Decimal(new int[] {
																					1024,
																					0,
																					0,
																					0});
			this.numericUpDownInterface6.Name = "numericUpDownInterface6";
			this.numericUpDownInterface6.ReadOnly = true;
			this.numericUpDownInterface6.Size = new System.Drawing.Size(48, 19);
			this.numericUpDownInterface6.TabIndex = 6;
			// 
			// checkBoxInterface5
			// 
			this.checkBoxInterface5.Enabled = false;
			this.checkBoxInterface5.Location = new System.Drawing.Point(240, 16);
			this.checkBoxInterface5.Name = "checkBoxInterface5";
			this.checkBoxInterface5.Size = new System.Drawing.Size(48, 16);
			this.checkBoxInterface5.TabIndex = 30;
			this.checkBoxInterface5.TabStop = false;
			this.checkBoxInterface5.Text = "ch4";
			// 
			// numericUpDownInterface5
			// 
			this.numericUpDownInterface5.Location = new System.Drawing.Point(240, 32);
			this.numericUpDownInterface5.Maximum = new System.Decimal(new int[] {
																					1024,
																					0,
																					0,
																					0});
			this.numericUpDownInterface5.Name = "numericUpDownInterface5";
			this.numericUpDownInterface5.ReadOnly = true;
			this.numericUpDownInterface5.Size = new System.Drawing.Size(48, 19);
			this.numericUpDownInterface5.TabIndex = 5;
			// 
			// checkBoxInterface4
			// 
			this.checkBoxInterface4.Enabled = false;
			this.checkBoxInterface4.Location = new System.Drawing.Point(192, 16);
			this.checkBoxInterface4.Name = "checkBoxInterface4";
			this.checkBoxInterface4.Size = new System.Drawing.Size(48, 16);
			this.checkBoxInterface4.TabIndex = 28;
			this.checkBoxInterface4.TabStop = false;
			this.checkBoxInterface4.Text = "ch3";
			// 
			// numericUpDownInterface4
			// 
			this.numericUpDownInterface4.Location = new System.Drawing.Point(192, 32);
			this.numericUpDownInterface4.Maximum = new System.Decimal(new int[] {
																					1024,
																					0,
																					0,
																					0});
			this.numericUpDownInterface4.Name = "numericUpDownInterface4";
			this.numericUpDownInterface4.ReadOnly = true;
			this.numericUpDownInterface4.Size = new System.Drawing.Size(48, 19);
			this.numericUpDownInterface4.TabIndex = 4;
			// 
			// checkBoxInterface3
			// 
			this.checkBoxInterface3.Enabled = false;
			this.checkBoxInterface3.Location = new System.Drawing.Point(144, 16);
			this.checkBoxInterface3.Name = "checkBoxInterface3";
			this.checkBoxInterface3.Size = new System.Drawing.Size(48, 16);
			this.checkBoxInterface3.TabIndex = 26;
			this.checkBoxInterface3.TabStop = false;
			this.checkBoxInterface3.Text = "ch2";
			// 
			// numericUpDownInterface3
			// 
			this.numericUpDownInterface3.Location = new System.Drawing.Point(144, 32);
			this.numericUpDownInterface3.Maximum = new System.Decimal(new int[] {
																					1024,
																					0,
																					0,
																					0});
			this.numericUpDownInterface3.Name = "numericUpDownInterface3";
			this.numericUpDownInterface3.ReadOnly = true;
			this.numericUpDownInterface3.Size = new System.Drawing.Size(48, 19);
			this.numericUpDownInterface3.TabIndex = 3;
			// 
			// checkBoxInterface2
			// 
			this.checkBoxInterface2.Enabled = false;
			this.checkBoxInterface2.Location = new System.Drawing.Point(96, 16);
			this.checkBoxInterface2.Name = "checkBoxInterface2";
			this.checkBoxInterface2.Size = new System.Drawing.Size(48, 16);
			this.checkBoxInterface2.TabIndex = 24;
			this.checkBoxInterface2.TabStop = false;
			this.checkBoxInterface2.Text = "ch1";
			// 
			// numericUpDownInterface2
			// 
			this.numericUpDownInterface2.Location = new System.Drawing.Point(96, 32);
			this.numericUpDownInterface2.Maximum = new System.Decimal(new int[] {
																					1024,
																					0,
																					0,
																					0});
			this.numericUpDownInterface2.Name = "numericUpDownInterface2";
			this.numericUpDownInterface2.ReadOnly = true;
			this.numericUpDownInterface2.Size = new System.Drawing.Size(48, 19);
			this.numericUpDownInterface2.TabIndex = 2;
			// 
			// checkBoxInterface1
			// 
			this.checkBoxInterface1.Enabled = false;
			this.checkBoxInterface1.Location = new System.Drawing.Point(48, 16);
			this.checkBoxInterface1.Name = "checkBoxInterface1";
			this.checkBoxInterface1.Size = new System.Drawing.Size(48, 16);
			this.checkBoxInterface1.TabIndex = 22;
			this.checkBoxInterface1.TabStop = false;
			this.checkBoxInterface1.Text = "ch0";
			// 
			// groupBox2
			// 
			this.groupBox2.Controls.Add(this.label12);
			this.groupBox2.Controls.Add(this.label11);
			this.groupBox2.Controls.Add(this.label10);
			this.groupBox2.Controls.Add(this.label9);
			this.groupBox2.Controls.Add(this.trackBarServo4);
			this.groupBox2.Controls.Add(this.trackBarServo3);
			this.groupBox2.Controls.Add(this.trackBarServo2);
			this.groupBox2.Controls.Add(this.trackBarServo1);
			this.groupBox2.Controls.Add(this.numericUpDownServo4);
			this.groupBox2.Controls.Add(this.numericUpDownServo3);
			this.groupBox2.Controls.Add(this.numericUpDownServo2);
			this.groupBox2.Controls.Add(this.numericUpDownServo1);
			this.groupBox2.Location = new System.Drawing.Point(16, 352);
			this.groupBox2.Name = "groupBox2";
			this.groupBox2.Size = new System.Drawing.Size(464, 96);
			this.groupBox2.TabIndex = 5;
			this.groupBox2.TabStop = false;
			this.groupBox2.Text = "T[{[^";
			// 
			// label12
			// 
			this.label12.Location = new System.Drawing.Point(360, 24);
			this.label12.Name = "label12";
			this.label12.Size = new System.Drawing.Size(32, 16);
			this.label12.TabIndex = 36;
			this.label12.Text = "CH3:";
			// 
			// label11
			// 
			this.label11.Location = new System.Drawing.Point(248, 24);
			this.label11.Name = "label11";
			this.label11.Size = new System.Drawing.Size(32, 16);
			this.label11.TabIndex = 35;
			this.label11.Text = "CH2:";
			// 
			// label10
			// 
			this.label10.Location = new System.Drawing.Point(144, 24);
			this.label10.Name = "label10";
			this.label10.Size = new System.Drawing.Size(32, 16);
			this.label10.TabIndex = 34;
			this.label10.Text = "CH1:";
			// 
			// label9
			// 
			this.label9.Location = new System.Drawing.Point(24, 24);
			this.label9.Name = "label9";
			this.label9.Size = new System.Drawing.Size(32, 16);
			this.label9.TabIndex = 33;
			this.label9.Text = "CH0:";
			// 
			// trackBarServo4
			// 
			this.trackBarServo4.LargeChange = 10;
			this.trackBarServo4.Location = new System.Drawing.Point(352, 48);
			this.trackBarServo4.Maximum = 180;
			this.trackBarServo4.Name = "trackBarServo4";
			this.trackBarServo4.Size = new System.Drawing.Size(96, 45);
			this.trackBarServo4.TabIndex = 4;
			this.trackBarServo4.TickFrequency = 10;
			this.trackBarServo4.ValueChanged += new System.EventHandler(this.trackBarServo4_ValueChanged);
			// 
			// trackBarServo3
			// 
			this.trackBarServo3.LargeChange = 10;
			this.trackBarServo3.Location = new System.Drawing.Point(240, 48);
			this.trackBarServo3.Maximum = 180;
			this.trackBarServo3.Name = "trackBarServo3";
			this.trackBarServo3.Size = new System.Drawing.Size(96, 45);
			this.trackBarServo3.TabIndex = 3;
			this.trackBarServo3.TickFrequency = 10;
			this.trackBarServo3.ValueChanged += new System.EventHandler(this.trackBarServo3_ValueChanged);
			// 
			// trackBarServo2
			// 
			this.trackBarServo2.LargeChange = 10;
			this.trackBarServo2.Location = new System.Drawing.Point(128, 48);
			this.trackBarServo2.Maximum = 180;
			this.trackBarServo2.Name = "trackBarServo2";
			this.trackBarServo2.Size = new System.Drawing.Size(96, 45);
			this.trackBarServo2.TabIndex = 2;
			this.trackBarServo2.TickFrequency = 10;
			this.trackBarServo2.ValueChanged += new System.EventHandler(this.trackBarServo2_ValueChanged);
			// 
			// trackBarServo1
			// 
			this.trackBarServo1.LargeChange = 10;
			this.trackBarServo1.Location = new System.Drawing.Point(16, 48);
			this.trackBarServo1.Maximum = 180;
			this.trackBarServo1.Name = "trackBarServo1";
			this.trackBarServo1.Size = new System.Drawing.Size(96, 45);
			this.trackBarServo1.TabIndex = 1;
			this.trackBarServo1.TickFrequency = 10;
			this.trackBarServo1.ValueChanged += new System.EventHandler(this.trackBarServo1_ValueChanged);
			// 
			// numericUpDownServo4
			// 
			this.numericUpDownServo4.Location = new System.Drawing.Point(400, 24);
			this.numericUpDownServo4.Maximum = new System.Decimal(new int[] {
																				1024,
																				0,
																				0,
																				0});
			this.numericUpDownServo4.Name = "numericUpDownServo4";
			this.numericUpDownServo4.ReadOnly = true;
			this.numericUpDownServo4.Size = new System.Drawing.Size(48, 19);
			this.numericUpDownServo4.TabIndex = 27;
			this.numericUpDownServo4.TabStop = false;
			// 
			// numericUpDownServo3
			// 
			this.numericUpDownServo3.Location = new System.Drawing.Point(288, 24);
			this.numericUpDownServo3.Maximum = new System.Decimal(new int[] {
																				1024,
																				0,
																				0,
																				0});
			this.numericUpDownServo3.Name = "numericUpDownServo3";
			this.numericUpDownServo3.ReadOnly = true;
			this.numericUpDownServo3.Size = new System.Drawing.Size(48, 19);
			this.numericUpDownServo3.TabIndex = 25;
			this.numericUpDownServo3.TabStop = false;
			// 
			// numericUpDownServo2
			// 
			this.numericUpDownServo2.Location = new System.Drawing.Point(176, 24);
			this.numericUpDownServo2.Maximum = new System.Decimal(new int[] {
																				1024,
																				0,
																				0,
																				0});
			this.numericUpDownServo2.Name = "numericUpDownServo2";
			this.numericUpDownServo2.ReadOnly = true;
			this.numericUpDownServo2.Size = new System.Drawing.Size(48, 19);
			this.numericUpDownServo2.TabIndex = 23;
			this.numericUpDownServo2.TabStop = false;
			// 
			// numericUpDownServo1
			// 
			this.numericUpDownServo1.Location = new System.Drawing.Point(64, 24);
			this.numericUpDownServo1.Maximum = new System.Decimal(new int[] {
																				1024,
																				0,
																				0,
																				0});
			this.numericUpDownServo1.Name = "numericUpDownServo1";
			this.numericUpDownServo1.ReadOnly = true;
			this.numericUpDownServo1.Size = new System.Drawing.Size(48, 19);
			this.numericUpDownServo1.TabIndex = 21;
			this.numericUpDownServo1.TabStop = false;
			// 
			// groupBoxWeight
			// 
			this.groupBoxWeight.Controls.Add(this.label1);
			this.groupBoxWeight.Controls.Add(this.label8);
			this.groupBoxWeight.Controls.Add(this.numericUpDownWeightThreshold);
			this.groupBoxWeight.Controls.Add(this.label5);
			this.groupBoxWeight.Controls.Add(this.numericUpDownWeight);
			this.groupBoxWeight.Controls.Add(this.label17);
			this.groupBoxWeight.Location = new System.Drawing.Point(168, 176);
			this.groupBoxWeight.Name = "groupBoxWeight";
			this.groupBoxWeight.Size = new System.Drawing.Size(160, 64);
			this.groupBoxWeight.TabIndex = 3;
			this.groupBoxWeight.TabStop = false;
			this.groupBoxWeight.Text = "̏dvZT";
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(120, 16);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(24, 16);
			this.label1.TabIndex = 30;
			this.label1.Text = "kg";
			// 
			// label8
			// 
			this.label8.Location = new System.Drawing.Point(24, 40);
			this.label8.Name = "label8";
			this.label8.Size = new System.Drawing.Size(32, 16);
			this.label8.TabIndex = 29;
			this.label8.Text = "臒l:";
			// 
			// numericUpDownWeightThreshold
			// 
			this.numericUpDownWeightThreshold.DecimalPlaces = 1;
			this.numericUpDownWeightThreshold.Location = new System.Drawing.Point(64, 40);
			this.numericUpDownWeightThreshold.Maximum = new System.Decimal(new int[] {
																						 136,
																						 0,
																						 0,
																						 0});
			this.numericUpDownWeightThreshold.Name = "numericUpDownWeightThreshold";
			this.numericUpDownWeightThreshold.Size = new System.Drawing.Size(48, 19);
			this.numericUpDownWeightThreshold.TabIndex = 2;
			this.numericUpDownWeightThreshold.Value = new System.Decimal(new int[] {
																					   5,
																					   0,
																					   0,
																					   65536});
			this.numericUpDownWeightThreshold.ValueChanged += new System.EventHandler(this.numericUpDownWeightThreshold_ValueChanged);
			// 
			// label5
			// 
			this.label5.Location = new System.Drawing.Point(24, 16);
			this.label5.Name = "label5";
			this.label5.Size = new System.Drawing.Size(32, 16);
			this.label5.TabIndex = 22;
			this.label5.Text = "d:";
			// 
			// numericUpDownWeight
			// 
			this.numericUpDownWeight.DecimalPlaces = 1;
			this.numericUpDownWeight.Location = new System.Drawing.Point(64, 16);
			this.numericUpDownWeight.Maximum = new System.Decimal(new int[] {
																				136,
																				0,
																				0,
																				0});
			this.numericUpDownWeight.Minimum = new System.Decimal(new int[] {
																				5,
																				0,
																				0,
																				-2147483648});
			this.numericUpDownWeight.Name = "numericUpDownWeight";
			this.numericUpDownWeight.ReadOnly = true;
			this.numericUpDownWeight.Size = new System.Drawing.Size(48, 19);
			this.numericUpDownWeight.TabIndex = 1;
			// 
			// label17
			// 
			this.label17.Location = new System.Drawing.Point(120, 40);
			this.label17.Name = "label17";
			this.label17.Size = new System.Drawing.Size(24, 16);
			this.label17.TabIndex = 39;
			this.label17.Text = "kg";
			// 
			// groupBoxAccel
			// 
			this.groupBoxAccel.Controls.Add(this.label18);
			this.groupBoxAccel.Controls.Add(this.numericUpDownAccelThresholdY);
			this.groupBoxAccel.Controls.Add(this.label7);
			this.groupBoxAccel.Controls.Add(this.numericUpDownAccelThresholdX);
			this.groupBoxAccel.Controls.Add(this.label4);
			this.groupBoxAccel.Controls.Add(this.numericUpDownAccelY);
			this.groupBoxAccel.Controls.Add(this.label3);
			this.groupBoxAccel.Controls.Add(this.numericUpDownAccelX);
			this.groupBoxAccel.Location = new System.Drawing.Point(328, 176);
			this.groupBoxAccel.Name = "groupBoxAccel";
			this.groupBoxAccel.Size = new System.Drawing.Size(240, 64);
			this.groupBoxAccel.TabIndex = 4;
			this.groupBoxAccel.TabStop = false;
			this.groupBoxAccel.Text = "xZT";
			// 
			// label18
			// 
			this.label18.Location = new System.Drawing.Point(112, 40);
			this.label18.Name = "label18";
			this.label18.Size = new System.Drawing.Size(40, 16);
			this.label18.TabIndex = 29;
			this.label18.Text = "臒lY:";
			// 
			// numericUpDownAccelThresholdY
			// 
			this.numericUpDownAccelThresholdY.DecimalPlaces = 2;
			this.numericUpDownAccelThresholdY.Increment = new System.Decimal(new int[] {
																						   1,
																						   0,
																						   0,
																						   131072});
			this.numericUpDownAccelThresholdY.Location = new System.Drawing.Point(152, 40);
			this.numericUpDownAccelThresholdY.Maximum = new System.Decimal(new int[] {
																						 1,
																						 0,
																						 0,
																						 0});
			this.numericUpDownAccelThresholdY.Name = "numericUpDownAccelThresholdY";
			this.numericUpDownAccelThresholdY.Size = new System.Drawing.Size(48, 19);
			this.numericUpDownAccelThresholdY.TabIndex = 4;
			this.numericUpDownAccelThresholdY.Value = new System.Decimal(new int[] {
																					   1,
																					   0,
																					   0,
																					   65536});
			this.numericUpDownAccelThresholdY.ValueChanged += new System.EventHandler(this.numericUpDownAccelThresholdY_ValueChanged);
			// 
			// label7
			// 
			this.label7.Location = new System.Drawing.Point(8, 40);
			this.label7.Name = "label7";
			this.label7.Size = new System.Drawing.Size(40, 16);
			this.label7.TabIndex = 27;
			this.label7.Text = "臒lX:";
			// 
			// numericUpDownAccelThresholdX
			// 
			this.numericUpDownAccelThresholdX.DecimalPlaces = 2;
			this.numericUpDownAccelThresholdX.Increment = new System.Decimal(new int[] {
																						   1,
																						   0,
																						   0,
																						   131072});
			this.numericUpDownAccelThresholdX.Location = new System.Drawing.Point(48, 40);
			this.numericUpDownAccelThresholdX.Maximum = new System.Decimal(new int[] {
																						 1,
																						 0,
																						 0,
																						 0});
			this.numericUpDownAccelThresholdX.Name = "numericUpDownAccelThresholdX";
			this.numericUpDownAccelThresholdX.Size = new System.Drawing.Size(48, 19);
			this.numericUpDownAccelThresholdX.TabIndex = 3;
			this.numericUpDownAccelThresholdX.Value = new System.Decimal(new int[] {
																					   1,
																					   0,
																					   0,
																					   65536});
			this.numericUpDownAccelThresholdX.ValueChanged += new System.EventHandler(this.numericUpDownAccelThresholdX_ValueChanged);
			// 
			// label4
			// 
			this.label4.Location = new System.Drawing.Point(112, 16);
			this.label4.Name = "label4";
			this.label4.Size = new System.Drawing.Size(40, 16);
			this.label4.TabIndex = 24;
			this.label4.Text = "XY:";
			// 
			// numericUpDownAccelY
			// 
			this.numericUpDownAccelY.DecimalPlaces = 2;
			this.numericUpDownAccelY.Increment = new System.Decimal(new int[] {
																				  1,
																				  0,
																				  0,
																				  131072});
			this.numericUpDownAccelY.Location = new System.Drawing.Point(152, 16);
			this.numericUpDownAccelY.Minimum = new System.Decimal(new int[] {
																				100,
																				0,
																				0,
																				-2147483648});
			this.numericUpDownAccelY.Name = "numericUpDownAccelY";
			this.numericUpDownAccelY.ReadOnly = true;
			this.numericUpDownAccelY.Size = new System.Drawing.Size(48, 19);
			this.numericUpDownAccelY.TabIndex = 2;
			// 
			// label3
			// 
			this.label3.Location = new System.Drawing.Point(8, 16);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(40, 16);
			this.label3.TabIndex = 22;
			this.label3.Text = "XX:";
			// 
			// numericUpDownAccelX
			// 
			this.numericUpDownAccelX.DecimalPlaces = 2;
			this.numericUpDownAccelX.Location = new System.Drawing.Point(48, 16);
			this.numericUpDownAccelX.Minimum = new System.Decimal(new int[] {
																				100,
																				0,
																				0,
																				-2147483648});
			this.numericUpDownAccelX.Name = "numericUpDownAccelX";
			this.numericUpDownAccelX.ReadOnly = true;
			this.numericUpDownAccelX.Size = new System.Drawing.Size(48, 19);
			this.numericUpDownAccelX.TabIndex = 1;
			// 
			// label13
			// 
			this.label13.Location = new System.Drawing.Point(64, 64);
			this.label13.Name = "label13";
			this.label13.Size = new System.Drawing.Size(40, 16);
			this.label13.TabIndex = 37;
			this.label13.Text = "|[g:";
			// 
			// groupBoxServer
			// 
			this.groupBoxServer.Controls.Add(this.checkBoxLocalHost);
			this.groupBoxServer.Controls.Add(this.comboBoxDelimiter);
			this.groupBoxServer.Controls.Add(this.label19);
			this.groupBoxServer.Controls.Add(this.textBoxIP);
			this.groupBoxServer.Controls.Add(this.label16);
			this.groupBoxServer.Controls.Add(this.buttonServerStop);
			this.groupBoxServer.Controls.Add(this.label13);
			this.groupBoxServer.Controls.Add(this.numericUpDownServerPort);
			this.groupBoxServer.Controls.Add(this.buttonServerStart);
			this.groupBoxServer.Location = new System.Drawing.Point(8, 0);
			this.groupBoxServer.Name = "groupBoxServer";
			this.groupBoxServer.Size = new System.Drawing.Size(272, 96);
			this.groupBoxServer.TabIndex = 1;
			this.groupBoxServer.TabStop = false;
			this.groupBoxServer.Text = "T[o[";
			// 
			// checkBoxLocalHost
			// 
			this.checkBoxLocalHost.Location = new System.Drawing.Point(120, 40);
			this.checkBoxLocalHost.Name = "checkBoxLocalHost";
			this.checkBoxLocalHost.Size = new System.Drawing.Size(128, 16);
			this.checkBoxLocalHost.TabIndex = 42;
			this.checkBoxLocalHost.Text = "localhostŗp";
			// 
			// comboBoxDelimiter
			// 
			this.comboBoxDelimiter.Items.AddRange(new object[] {
																   "\\r\\n",
																   "\\r",
																   "\\n",
																   "\\0"});
			this.comboBoxDelimiter.Location = new System.Drawing.Point(216, 64);
			this.comboBoxDelimiter.Name = "comboBoxDelimiter";
			this.comboBoxDelimiter.Size = new System.Drawing.Size(48, 20);
			this.comboBoxDelimiter.TabIndex = 5;
			this.comboBoxDelimiter.Text = "\\r\\n";
			this.comboBoxDelimiter.SelectedIndexChanged += new System.EventHandler(this.comboBoxDelimiter_SelectedIndexChanged);
			// 
			// label19
			// 
			this.label19.Location = new System.Drawing.Point(168, 64);
			this.label19.Name = "label19";
			this.label19.Size = new System.Drawing.Size(40, 16);
			this.label19.TabIndex = 41;
			this.label19.Text = "f~^:";
			// 
			// textBoxIP
			// 
			this.textBoxIP.Location = new System.Drawing.Point(96, 16);
			this.textBoxIP.Name = "textBoxIP";
			this.textBoxIP.ReadOnly = true;
			this.textBoxIP.Size = new System.Drawing.Size(104, 19);
			this.textBoxIP.TabIndex = 3;
			this.textBoxIP.Text = "";
			// 
			// label16
			// 
			this.label16.Location = new System.Drawing.Point(72, 16);
			this.label16.Name = "label16";
			this.label16.Size = new System.Drawing.Size(24, 16);
			this.label16.TabIndex = 40;
			this.label16.Text = "IP:";
			// 
			// buttonServerStop
			// 
			this.buttonServerStop.Enabled = false;
			this.buttonServerStop.Location = new System.Drawing.Point(8, 56);
			this.buttonServerStop.Name = "buttonServerStop";
			this.buttonServerStop.Size = new System.Drawing.Size(48, 24);
			this.buttonServerStop.TabIndex = 2;
			this.buttonServerStop.Text = "~";
			this.buttonServerStop.Click += new System.EventHandler(this.buttonServerStop_Click);
			// 
			// numericUpDownServerPort
			// 
			this.numericUpDownServerPort.Location = new System.Drawing.Point(104, 64);
			this.numericUpDownServerPort.Maximum = new System.Decimal(new int[] {
																					65536,
																					0,
																					0,
																					0});
			this.numericUpDownServerPort.Name = "numericUpDownServerPort";
			this.numericUpDownServerPort.Size = new System.Drawing.Size(48, 19);
			this.numericUpDownServerPort.TabIndex = 4;
			this.numericUpDownServerPort.Value = new System.Decimal(new int[] {
																				  4321,
																				  0,
																				  0,
																				  0});
			// 
			// buttonServerStart
			// 
			this.buttonServerStart.Location = new System.Drawing.Point(8, 24);
			this.buttonServerStart.Name = "buttonServerStart";
			this.buttonServerStart.Size = new System.Drawing.Size(48, 23);
			this.buttonServerStart.TabIndex = 1;
			this.buttonServerStart.Text = "Jn";
			this.buttonServerStart.Click += new System.EventHandler(this.buttonServerStart_Click);
			// 
			// groupBoxPhidget
			// 
			this.groupBoxPhidget.Controls.Add(this.groupBoxInterfacekit);
			this.groupBoxPhidget.Controls.Add(this.groupBoxRFID);
			this.groupBoxPhidget.Controls.Add(this.groupBoxWeight);
			this.groupBoxPhidget.Controls.Add(this.groupBoxAccel);
			this.groupBoxPhidget.Location = new System.Drawing.Point(8, 104);
			this.groupBoxPhidget.Name = "groupBoxPhidget";
			this.groupBoxPhidget.Size = new System.Drawing.Size(576, 352);
			this.groupBoxPhidget.TabIndex = 3;
			this.groupBoxPhidget.TabStop = false;
			this.groupBoxPhidget.Text = "Phidget";
			// 
			// PhidgetForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 12);
			this.ClientSize = new System.Drawing.Size(592, 464);
			this.Controls.Add(this.groupBoxServer);
			this.Controls.Add(this.groupBox1);
			this.Controls.Add(this.groupBox2);
			this.Controls.Add(this.groupBoxPhidget);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle;
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.MaximizeBox = false;
			this.Name = "PhidgetForm";
			this.Text = "PhidgetServer";
			this.groupBoxRFID.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownRFID)).EndInit();
			this.groupBox1.ResumeLayout(false);
			this.groupBoxInterfacekit.ResumeLayout(false);
			this.groupBoxOutput.ResumeLayout(false);
			this.groupBoxInput.ResumeLayout(false);
			this.groupBoxSensor.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownInterfaceT8)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownInterfaceT7)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownInterfaceT1)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownInterfaceT6)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownInterfaceT5)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownInterfaceT4)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownInterfaceT3)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownInterfaceT2)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownInterface8)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownInterface7)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownInterface1)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownInterface6)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownInterface5)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownInterface4)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownInterface3)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownInterface2)).EndInit();
			this.groupBox2.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.trackBarServo4)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.trackBarServo3)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.trackBarServo2)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.trackBarServo1)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownServo4)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownServo3)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownServo2)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownServo1)).EndInit();
			this.groupBoxWeight.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownWeightThreshold)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownWeight)).EndInit();
			this.groupBoxAccel.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownAccelThresholdY)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownAccelThresholdX)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownAccelY)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownAccelX)).EndInit();
			this.groupBoxServer.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownServerPort)).EndInit();
			this.groupBoxPhidget.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		#region Phidget Manager֘A(Attach/Detach)

		private void StartManager()
		{
			phidgetManager = new PHIDGET.PhidgetManagerClass();
			phidgetManager.OnAttach += new PHIDGET._IPhidgetManagerEvents_OnAttachEventHandler(OnManagerAttach);
			phidgetManager.OnDetach += new PHIDGET._IPhidgetManagerEvents_OnDetachEventHandler(OnManagerDetach);
		}

		private void OnManagerAttach(PHIDGET.IPhidget phidget)
		{
			switch(phidget.DeviceType)
			{
				case PHIDGET_ACCEL_NAME:
					StartAccel();
					if(server != null)
						server.WriteAllSockets(new Command.Accel(Command.States.Attach).ToString());
					break;
				case PHIDGET_RFID_NAME:
					StartRFID();
					if(server != null)
						server.WriteAllSockets(new Command.RFID(Command.States.Attach).ToString());
					break;
				case PHIDGET_WEIGHT_NAME:
					StartWeight();
					if(server != null)
						server.WriteAllSockets(new Command.Weight(Command.States.Attach).ToString());
					break;
				case PHIDGET_INTERFACE_NAME:
					StartInterface();
					if(server != null)
						server.WriteAllSockets(new Command.InterfaceKit(Command.States.Attach).ToString());
					break;
				case  PHIDGET_SERVO_NAME:
					StartServo();
					if(server != null)
						server.WriteAllSockets(new Command.Servo(Command.States.Attach).ToString());
					break;
			}
			PrintMessage("Attached: {0}",phidget.DeviceType);
		}

		private void OnManagerDetach(PHIDGET.IPhidget phidget)
		{
			switch(phidget.DeviceType)
			{
				case PHIDGET_ACCEL_NAME:
					StopAccel();
					if(server != null)
						server.WriteAllSockets(new Command.Accel(Command.States.Detach).ToString());
					break;
				case PHIDGET_RFID_NAME:
					StopRFID();
					if(server != null)
						server.WriteAllSockets(new Command.RFID(Command.States.Detach).ToString());
					break;
				case PHIDGET_WEIGHT_NAME:
					StopWeight();
					if(server != null)
						server.WriteAllSockets(new Command.Weight(Command.States.Detach).ToString());
					break;
				case PHIDGET_INTERFACE_NAME:
					StopInterface();
					if(server != null)
						server.WriteAllSockets(new Command.InterfaceKit(Command.States.Detach).ToString());
					break;
				case PHIDGET_SERVO_NAME:
					StopServo();
					if(server != null)
						server.WriteAllSockets(new Command.Servo(Command.States.Detach).ToString());
					break;
			}
			PrintMessage("Detached: {0}", phidget.DeviceType);
		}

		#endregion

		#region ̏dvZT[֘A
		bool StartWeight()
		{
			phidgetWeight = new PHIDGET.PhidgetWeightSensorClass();
			try
			{
				phidgetWeight.Open(false, -1);
				if(!phidgetWeight.IsAttached)
				{
					PrintError("No Weight Sensor found...");	
					return false;
				}

				PrintDebug("{0}: version:{1}\n", phidgetWeight.DeviceType, phidgetWeight.DeviceVersion);
				
				phidgetWeight.WeightChangeTrigger = (double)numericUpDownWeightThreshold.Value;
				phidgetWeight.OnWeightChange  += new  PHIDGET._IPhidgetWeightSensorEvents_OnWeightChangeEventHandler(OnWeightChange);
				
			}
		
			catch(COMException ex)
			{
				PrintError(ex.Message);
				return false;
			}
			return true;
		}

		void StopWeight()
		{
			phidgetWeight = null;
		}

		void OnWeightChange(double w)
		{
			PrintDebug("Weight:{0}", w);
			numericUpDownWeight.Value =(decimal)w;

			Command.Weight weight = new Command.Weight(Command.States.In, w);
			DealEvent(weight);

			if(server != null)
				server.WriteAllSockets(weight.ToString());
		}

		private void numericUpDownWeightThreshold_ValueChanged(object sender, System.EventArgs e)
		{
			if(phidgetWeight != null)
			{
				phidgetWeight.WeightChangeTrigger = (double)numericUpDownWeightThreshold.Value;
			}
		}
		#endregion

		#region RFIDZT[֘A
		bool StartRFID()
		{
			phidgetRFID = new PHIDGET.PhidgetRFIDClass();
			try
			{
				phidgetRFID.Open(false, -1);
				if(!phidgetRFID.IsAttached)
				{
					PrintError("No RFID found...");	
					return false;
				}

				PrintDebug("{0}: version:{1}\n", phidgetRFID.DeviceType, phidgetRFID.DeviceVersion);
				
				phidgetRFID.set_OutputState(3, true);
				phidgetRFID.OnTag  += new  PHIDGET._IPhidgetRFIDEvents_OnTagEventHandler(OnRFIDChange);
			}
		
			catch(COMException ex)
			{
				PrintError(ex.Message);
				return false;
			}
			return true;
		}

		void StopRFID()
		{
			phidgetRFID = null;
		}
		
		void OnRFIDChange(string tag)
		{

			foreach(string id in DISCARD_IDS)
			{
				if(tag == id)
					return;
			}
			
			//phidgetRFID.set_OutputState(2, !phidgetRFID.get_OutputState(2));
			
			if(tag != textBoxRFID.Text)
			{
				phidgetRFID.set_OutputState(2,true);
				
				PrintDebug("Tag:{0}", tag);
				textBoxRFID.Text = tag;
				Command.RFID rfid = new Command.RFID(Command.States.In, tag);

				DealEvent(rfid);
				if(server != null)
					server.WriteAllSockets(rfid.ToString());
			}

			if(rfidThread == null)
			{
				rfidThread = new Thread(new ThreadStart(RfidWorker));
				rfidThread.Start();
			}
			else
			{
				rfidUpdated = true;
			}
			Application.DoEvents();			
			return;
		}

		//^OoXbhD
		void RfidWorker()
		{
			try
			{	
				while(true)
				{
					Thread.Sleep((int)((double)numericUpDownRFID.Value * 1000));

					if(phidgetRFID == null)
						break;

					//XVς݂Ȃp
					if(rfidUpdated)
					{
						rfidUpdated = false;
						continue;
					}
					else
					{
						PrintDebug("Tag:Removed");
						textBoxRFID.Text = "0";
						phidgetRFID.set_OutputState(2,false);

						Command.RFID rfid = new Command.RFID(Command.States.In, "0");

						DealEvent(rfid);


						if(server != null)
							server.WriteAllSockets(rfid.ToString());
						break;
					}
				}
			}
			catch(ThreadAbortException ex)
			{
			}
			catch(Exception ex)
			{
				PrintError(ex.Message);
			}
			finally
			{
				if(rfidThread != null)
					rfidThread = null;
			}
		}

		private void numericUpDownRFID_ValueChanged(object sender, System.EventArgs e)
		{
			
		}

		#endregion

		#region xZT[֘A
		bool StartAccel()
		{
			phidgetAccel = new PHIDGET.PhidgetAccelerometerClass();
			
			try
			{
				phidgetAccel.Open(false,-1);
	
				if(!phidgetAccel.IsAttached)
				{
					PrintMessage("No Accelerometer found...");	
					return false;
				}

				PrintDebug("{0}: version:{1}\n", phidgetAccel.DeviceType, phidgetAccel.DeviceVersion);
				
				phidgetAccel.set_AccelerationChangeTrigger(0, (double)numericUpDownAccelThresholdX.Value);
				phidgetAccel.set_AccelerationChangeTrigger(1, (double)numericUpDownAccelThresholdY.Value);

				phidgetAccel.OnAccelerationChange += 
					new PHIDGET._IPhidgetAccelerometerEvents_OnAccelerationChangeEventHandler(OnAccelerationChange);
				
			}
			catch(COMException ex)
			{
				PrintError(ex.Message);
				return false;
			}
			return true;
		}

		void StopAccel()
		{
			phidgetAccel = null;
		}
		
		void OnAccelerationChange(int id, double val)
		{
			PrintDebug("{0}:{1:000.000}", id, val);
			numericAccels[id].Value = (decimal)val;
			
			Command.Accel accel = new Command.Accel(Command.States.In,id, val);

			DealEvent(accel);

			if(server != null)
			{
				server.WriteAllSockets(accel.ToString());
			}
		}

		private void numericUpDownAccelThresholdX_ValueChanged(object sender, System.EventArgs e)
		{
			if(phidgetAccel != null)
			{
				phidgetAccel.set_AccelerationChangeTrigger(0, (float)numericUpDownAccelThresholdX.Value);
			}
		}

		private void numericUpDownAccelThresholdY_ValueChanged(object sender, System.EventArgs e)
		{
			if(phidgetAccel != null)
			{
				phidgetAccel.set_AccelerationChangeTrigger(1,(float)numericUpDownAccelThresholdY.Value);
			}
		}
		#endregion

		#region T[{[^֘A
		bool StartServo()
		{
			phidgetServo = new PHIDGET.PhidgetServoClass();
			
			try
			{
				phidgetServo.Open(false,-1);
	
				if(!phidgetServo.IsAttached)
				{
					PrintError("No Servo Controller found...");	
					return false;
				}

				PrintDebug("{0}: version:{1}\n", phidgetServo.DeviceType, phidgetServo.DeviceVersion);
				
				phidgetServo.set_MotorPosition(0, trackBarServo1.Value);
				phidgetServo.set_MotorPosition(1, trackBarServo2.Value);
				phidgetServo.set_MotorPosition(2, trackBarServo3.Value);
				phidgetServo.set_MotorPosition(3, trackBarServo4.Value);
			}
			catch(COMException ex)
			{
				PrintError(ex.Message);
				return false;
			}
			return true;
		}

		void StopServo()
		{
			phidgetServo = null;
		}

		private void trackBarServo1_ValueChanged(object sender, System.EventArgs e)
		{
			numericUpDownServo1.Value = trackBarServo1.Value;
			if(phidgetServo != null && phidgetServo.IsAttached)
				phidgetServo.set_MotorPosition(0, trackBarServo1.Value);
		}

		private void trackBarServo2_ValueChanged(object sender, System.EventArgs e)
		{
			numericUpDownServo2.Value = trackBarServo2.Value;
			if(phidgetServo != null && phidgetServo.IsAttached && phidgetServo.NumMotors > 1)
				phidgetServo.set_MotorPosition(1, trackBarServo2.Value);
		}

		private void trackBarServo3_ValueChanged(object sender, System.EventArgs e)
		{
			numericUpDownServo3.Value = trackBarServo3.Value;
			if(phidgetServo != null && phidgetServo.IsAttached && phidgetServo.NumMotors > 1)
				phidgetServo.set_MotorPosition(2, trackBarServo3.Value);
		}

		private void trackBarServo4_ValueChanged(object sender, System.EventArgs e)
		{
			numericUpDownServo4.Value = trackBarServo4.Value;
			if(phidgetServo != null && phidgetServo.IsAttached && phidgetServo.NumMotors > 1)
				phidgetServo.set_MotorPosition(3, trackBarServo4.Value);
		}

		#endregion

		#region C^tF[XLbg֘A

		private bool StartInterface()
		{
			phidgetInterface = new PHIDGET.PhidgetInterfaceKitClass();
			try
			{
				phidgetInterface.Open(false, -1);
				if(!phidgetInterface.IsAttached)
				{
					PrintError("No InterfaceKit found...");	
					return false;
				}

				PrintDebug("{0}: version:{1}\n", phidgetInterface.DeviceType, phidgetInterface.DeviceVersion);

				for(int i=0;i<8;i++)
				{
					phidgetInterface.set_SensorChangeTrigger(i, (int)numericInterfaceTs[i].Value);
				}

				phidgetInterface.OnSensorChange += new  PHIDGET._IPhidgetInterfaceKitEvents_OnSensorChangeEventHandler(OnInterfaceSensorChange);
				phidgetInterface.OnInputChange += new PHIDGET._IPhidgetInterfaceKitEvents_OnInputChangeEventHandler(OnInterfaceInputChange);
			}
		
			catch(COMException ex)
			{
				PrintError(ex.Message);
				return false;
			}
			return true;
		}

		private void StopInterface()
		{
			phidgetInterface = null;
			foreach(CheckBox box in checkBoxInterfaces)
			{
				box.Checked = false;
			}
		}

		private void OnInterfaceSensorChange(int index, int newVal)//(object sender, GroupLab.Phidgets.Components.EventArguments.IndexSensorChangeEventArgs e)
		{
			PrintDebug("InterfaceKit:Sensor:{0}: {1}", index, newVal);
			checkBoxInterfaces[index].Checked = true;
			numericInterfaces[index].Value = newVal;

			Command.InterfaceKit interfaceKit = new Command.InterfaceKit(Command.States.In,
											   Command.SubTypes.Analog,
											   index,
											   newVal);
			DealEvent(interfaceKit);

			if(server != null)
				server.WriteAllSockets(interfaceKit.ToString());
		}

		private void OnInterfaceInputChange(int index, bool newFlag)
		{
			PrintDebug("InterfaceKit:Input:{0}: {1}", index, newFlag);
			checkBoxInputs[index].Checked = newFlag;

			int newVal = 0;
				
			if(newFlag)
				newVal = 1;
			Command.InterfaceKit interfaceKit = new Command.InterfaceKit(Command.States.In,
														Command.SubTypes.Digital,
														index,
														newVal);

			DealEvent(interfaceKit);

			if(server != null)
			{
				server.WriteAllSockets(interfaceKit.ToString());
			}
		}

		private void numericUpDownInterfaceT1_ValueChanged(object sender, System.EventArgs e)
		{
			if(phidgetInterface != null && phidgetInterface.IsAttached)
			{
				phidgetInterface.set_SensorChangeTrigger(0, (int)numericInterfaceTs[0].Value);
			}
		}

		private void numericUpDownInterfaceT2_ValueChanged(object sender, System.EventArgs e)
		{
			if(phidgetInterface != null && phidgetInterface.IsAttached)
			{
				phidgetInterface.set_SensorChangeTrigger(1, (int)numericInterfaceTs[1].Value);
			}
		}

		private void numericUpDownInterfaceT3_ValueChanged(object sender, System.EventArgs e)
		{
			if(phidgetInterface != null && phidgetInterface.IsAttached)
			{
				phidgetInterface.set_SensorChangeTrigger(2, (int)numericInterfaceTs[2].Value);
			}
		}

		private void numericUpDownInterfaceT4_ValueChanged(object sender, System.EventArgs e)
		{
			if(phidgetInterface != null && phidgetInterface.IsAttached)
			{
				phidgetInterface.set_SensorChangeTrigger(3, (int)numericInterfaceTs[3].Value);
			}
		}

		private void numericUpDownInterfaceT5_ValueChanged(object sender, System.EventArgs e)
		{
			if(phidgetInterface != null && phidgetInterface.IsAttached)
			{
				phidgetInterface.set_SensorChangeTrigger(4, (int)numericInterfaceTs[4].Value);
			}
		
		}

		private void numericUpDownInterfaceT6_ValueChanged(object sender, System.EventArgs e)
		{
			if(phidgetInterface != null && phidgetInterface.IsAttached)
			{
				phidgetInterface.set_SensorChangeTrigger(5, (int)numericInterfaceTs[5].Value);
			}
		}

		private void numericUpDownInterfaceT7_ValueChanged(object sender, System.EventArgs e)
		{
			if(phidgetInterface != null && phidgetInterface.IsAttached)
			{
				phidgetInterface.set_SensorChangeTrigger(6, (int)numericInterfaceTs[6].Value);
			}
		}

		private void numericUpDownInterfaceT8_ValueChanged(object sender, System.EventArgs e)
		{
			if(phidgetInterface != null && phidgetInterface.IsAttached)
			{
				phidgetInterface.set_SensorChangeTrigger(7, (int)numericInterfaceTs[7].Value);
			}
		}

		private void checkBoxOutput1_CheckedChanged(object sender, System.EventArgs e)
		{
			if(phidgetInterface != null && phidgetInterface.IsAttached)
			{
				phidgetInterface.set_OutputState(0, ((CheckBox)sender).Checked);
			}
		}

		private void checkBoxOutput2_CheckedChanged(object sender, System.EventArgs e)
		{
			if(phidgetInterface != null && phidgetInterface.IsAttached)
			{
				phidgetInterface.set_OutputState(1, ((CheckBox)sender).Checked);
			}		
		}

		private void checkBoxOutput3_CheckedChanged(object sender, System.EventArgs e)
		{
			if(phidgetInterface != null && phidgetInterface.IsAttached)
			{
				phidgetInterface.set_OutputState(2, ((CheckBox)sender).Checked);
			}
		}

		private void checkBoxOutput4_CheckedChanged(object sender, System.EventArgs e)
		{
			if(phidgetInterface != null && phidgetInterface.IsAttached)
			{
				phidgetInterface.set_OutputState(3, ((CheckBox)sender).Checked);
			}
		}

		private void checkBoxOutput5_CheckedChanged(object sender, System.EventArgs e)
		{
			if(phidgetInterface != null && phidgetInterface.IsAttached)
			{
				phidgetInterface.set_OutputState(4, ((CheckBox)sender).Checked);
			}
		}

		private void checkBoxOutput6_CheckedChanged(object sender, System.EventArgs e)
		{
			if(phidgetInterface != null && phidgetInterface.IsAttached)
			{
				phidgetInterface.set_OutputState(5, ((CheckBox)sender).Checked);
			}
		}

		private void checkBoxOutput7_CheckedChanged(object sender, System.EventArgs e)
		{
			if(phidgetInterface != null && phidgetInterface.IsAttached)
			{
				phidgetInterface.set_OutputState(6, ((CheckBox)sender).Checked);
			}
		}

		private void checkBoxOutput8_CheckedChanged(object sender, System.EventArgs e)
		{
			if(phidgetInterface != null && phidgetInterface.IsAttached)
			{
				phidgetInterface.set_OutputState(7, ((CheckBox)sender).Checked);
			}
		}

		#endregion

		#region bZ[W֘A
		//sR[htŎMbZ[W\
		private void PrintMessage(string m, params object []args)
		{	
			if(textBoxMessage.Text.Length > TEXTBOX_CNT_MAX)
				textBoxMessage.Clear();

			string message = String.Format(m, args);
			textBoxMessage.Text = message + "\r\n" + textBoxMessage.Text;
		}

		//G[bZ[W\D
		private void PrintError(string m, params object []args)
		{
			PrintMessage("Error: " + m, args);
		}

		//fobObZ[W\D
		private void PrintDebug(string m, params object []args)
		{
			if(checkBoxDebug.Checked)
				PrintMessage(m, args);
		}

		#endregion

		#region T[o[֘A
		private void buttonServerStart_Click(object sender, System.EventArgs e)
		{
			
			string hostname = "";
			IPAddress ipAddress = null;

			try
			{
				if(!checkBoxLocalHost.Checked)
				{
					hostname = Dns.GetHostName();
					ipAddress = Dns.Resolve(hostname).AddressList[0];
				}
				else
				{
					ipAddress = IPAddress.Parse(LOCAL_IP);
				}
			}
			catch(Exception ex)
			{
				PrintError(ex.Message);
				return;
			}
			
			buttonServerStart.Enabled = false;
			textBoxIP.Text = ipAddress.ToString();

			server = new PhidgetServer(ipAddress,(int)numericUpDownServerPort.Value);
			server.phidgetMessageHandler += new PhidgetServer.PhidgetMessageHandler(OnPhidgetMessageEvent);
			server.phidgetServerHandler += new PhidgetServer.PhidgetServerHandler(OnPhidgetServerEvent);
			if(server.Start())
			{
				//buttonServerStart.Enabled = false;
				buttonServerStop.Enabled = true;
				numericUpDownServerPort.Enabled = false;
				comboBoxDelimiter.Enabled = false;
				checkBoxLocalHost.Enabled = false;
			}
			else
			{
				buttonServerStart.Enabled = true;
			}
		}

		private void buttonServerStop_Click(object sender, System.EventArgs e)
		{
			if(server != null)
			{
				server.Stop();
			}

			buttonServerStop.Enabled = false;
			buttonServerStart.Enabled = true;
			numericUpDownServerPort.Enabled = true;
			comboBoxDelimiter.Enabled = true;
			checkBoxLocalHost.Enabled = true;
		}

		private void comboBoxDelimiter_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			Command.DELIMITER_LINE = Regex.Unescape(comboBoxDelimiter.Text);
		}

		void OnPhidgetMessageEvent(object sender, PhidgetServer.PhidgetMessageEventArgs e)
		{
			if(e.Debug)
				PrintDebug(e.Message);
			else
				PrintMessage(e.Message);
		}

		void OnPhidgetServerEvent(object sender, PhidgetServer.PhidgetServerEventArgs e)
		{
			try
			{
				switch(e.Phidget.Type)
				{
					case Command.Types.InterfaceKit:
					{
						Command.InterfaceKit ik = (Command.InterfaceKit)e.Phidget;
							
						if(ik.Port < Command.InterfaceKit.PORT_MAX)
						{
						
							switch(ik.State)
							{
								case Command.States.Threshold:
									numericInterfaceTs[ik.Port].Value = ik.Data;
									break;
								case Command.States.Out:
									if(ik.Data == 1)
									{
										checkBoxOutputs[ik.Port].Checked =  true;
									}
									else if (ik.Data == 0)
									{
										checkBoxOutputs[ik.Port].Checked = false;
									}
									break;
							}
						}
						break;
					}
					case Command.Types.Servo:
					{
						Command.Servo s = (Command.Servo)e.Phidget;

						if(s.Port < Command.Servo.PORT_MAX)
						{
							switch(s.State)
							{
								case Command.States.Out:
									trackBarServos[s.Port].Value = s.Data;
									break;
							}
						}
						break;
					}
					case Command.Types.Accel:
					{
						Command.Accel a = (Command.Accel)e.Phidget;

						switch(a.State)
						{
							case Command.States.Threshold:
								numericAccelTs[a.Port].Value = (decimal)a.Data;
								break;
						}
						break;
					}
					case Command.Types.Weight:
					{
						Command.Weight w = (Command.Weight)e.Phidget;

						switch(w.State)
						{
							case Command.States.Threshold:
								numericUpDownWeightThreshold.Value = (decimal)w.Data;
								break;
						}
						break;
					}
					case Command.Types.RFID:
					{
						Command.RFID r = (Command.RFID)e.Phidget;

						switch(r.State)
						{
							case Command.States.Threshold:
								numericUpDownRFID.Value = (decimal)double.Parse(r.Data);
								break;
						}
						break;
					}
				}
			}
			catch(Exception ex)
			{
				PrintError(ex.Message);
			}
		}

		#endregion

		#region ݒt@CSave/Load
		//ݒt@C̕ۑ
		private void SaveSettings()
		{
			StreamWriter fileStream = null;
			try
			{
				fileStream = new StreamWriter(Application.StartupPath + @"\" + SETTING_FILE, false);
				fileStream.WriteLine("Port\t{0}",numericUpDownServerPort.Value);
				try
				{
					fileStream.WriteLine("Delimiter\t{0}",comboBoxDelimiter.SelectedItem.ToString());	
				}
				catch
				{
					fileStream.WriteLine("Delimiter\t{0}",comboBoxDelimiter.Items[0].ToString());	
				}
				fileStream.WriteLine("Debug\t{0}",checkBoxDebug.Checked);
				fileStream.Write("InterfaceKit-Threshold");
				for(int i=0;i<numericInterfaceTs.Length;i++)
				{
					fileStream.Write("\t{0}",numericInterfaceTs[i].Value);
				}
				fileStream.WriteLine();
				
				fileStream.Write("InterfaceKit-Output");
				for(int i=0;i<checkBoxOutputs.Length;i++)
				{
					fileStream.Write("\t{0}",checkBoxOutputs[i].Checked);
				}
				fileStream.WriteLine();
				
				fileStream.WriteLine("RFID-Interval\t{0}", numericUpDownRFID.Value);
				fileStream.WriteLine("Weight-Threshold\t{0}", numericUpDownWeightThreshold.Value);
				
				fileStream.Write("Accel-Threshold");
				for(int i=0;i<numericAccelTs.Length;i++)
				{
					fileStream.Write("\t{0}",numericAccelTs[i].Value);
				}
				fileStream.WriteLine();

				fileStream.Write("Servo");
				for(int i=0;i<trackBarServos.Length;i++)
				{
					fileStream.Write("\t{0}",trackBarServos[i].Value);
				}
				fileStream.WriteLine();
			}
			catch(IOException ex)
			{
				PrintMessage(ex.Message);
			}
			finally
			{
				if(fileStream != null)
				{
					fileStream.Close();
					fileStream = null;
				}
			}
		}

		//ݒt@C̓ǂݏo
		private void LoadSettings()
		{
			StreamReader fileStream = null;
			
			try
			{
				//t@CȂΏI
				if(!File.Exists(Application.StartupPath + @"\" + SETTING_FILE))
					return;

				fileStream = new StreamReader(Application.StartupPath + @"\" + SETTING_FILE);
				
				for(int i= 0;i<SETTING_CNT;i++)
				{
					string [] args;
					string line = fileStream.ReadLine();

					if(line == null)
						break;

					args = line.Split("\t".ToCharArray());

					if(args.Length < 2)
						continue;

					switch(i)
					{
						case 0:
							try
							{
								numericUpDownServerPort.Value = int.Parse(args[1]);
							}
							catch{}
							break;

						case 1:
							try
							{
								comboBoxDelimiter.Text = args[1];
							}
							catch{}
							break;

						case 2:
							try
							{
								checkBoxDebug.Checked = bool.Parse(args[1]);
							}
							catch{}
							break;
						case 3:
							try
							{
								for(int j=0;j<numericInterfaceTs.Length;j++)
								{
									numericInterfaceTs[j].Value = int.Parse(args[j+1]);
								}
							}
							catch{}
							break;
						case 4:
							try
							{
								for(int j=0;j<checkBoxOutputs.Length;j++)
								{
									checkBoxOutputs[j].Checked = bool.Parse(args[j+1]);
								}
							}
							catch{}
							break;
						case 5:
							try
							{
								numericUpDownRFID.Value = int.Parse(args[1]);
							}
							catch{}
							break;
						case 6:
							try
							{
								numericUpDownWeightThreshold.Value = (decimal)double.Parse(args[1]);
							}
							catch{}
							break;
						case 7:
							try
							{
								for(int j=0;j<numericAccelTs.Length;j++)
								{
									numericAccelTs[j].Value = (decimal)double.Parse(args[j+1]);
								}
							}
							catch{}
							break;
						case 8:
							try
							{
								for(int j=0;j<trackBarServos.Length;j++)
								{
									trackBarServos[j].Value = int.Parse(args[j+1]);
								}
							}
							catch{}
							break;
					}
				}
			}
			catch(IOException ex)
			{
				PrintError(ex.Message);
			}
			finally
			{
				if(fileStream != null)
				{
					fileStream.Close();
					fileStream = null;
				}
			}
		}

		#endregion

		//C#ŒڃCxgꍇCȉҏWDi݂͖gpj
		void DealEvent(Command.Phidget phidget)
		{	
			switch(phidget.Type)
			{
				case Command.Types.InterfaceKit:
					Command.InterfaceKit interfaceKit = ((Command.InterfaceKit)phidget);
					break;
				case Command.Types.RFID:
					Command.RFID rfid = ((Command.RFID)phidget);
					break;
				case Command.Types.Accel:
					Command.Accel accel = ((Command.Accel)phidget);
					break;
				case Command.Types.Weight:
					Command.Weight weight = ((Command.Weight)phidget);
					break;
			}
			return;
		}

		[STAThread]
		static void Main() 
		{
			Application.Run(new PhidgetForm());
		}
		
	}
}